local p14 = "$path_bs_do\EFH_2014_08\"
local p17 = "$path0\2017\"
local fD14="f4"   // code is almost the same as EFH_10_11, but bank debts are now 1 2 5 (instead of 1 2 4) and retail 3 4 (instead of 3 5)
local fD17="f4"   // also now we have cf_td`k'_`h' plus d_td`k'_`h'  instead of  d_`h'_td`k' plus cf_`h'_td`k'
foreach yr of numlist 14 17 { // Create Debt and CF for each Bank  // `fD`yr''
use "`p`yr''\EFH_`yr'_allvars.dta", clear
capture drop a1
g a1=(ord==1)
keep if a1==1
keep folio a1 `fD`yr''* cf_* d_*
sum `fD`yr''*
capture drop f3_1e* 
capture drop f4_t9 f4_1e*
forv k=1/5 { // Each Debt Type replace unusual combinations of Debt and CF
	forv h=1/3 {  // Debt number 1 to 3
	replace d_td`k'_`h' = max(d_td`k'_`h', cf_td`k'_`h') if d_td`k'_`h'<. 
	sum cf_td`k'_`h' if d_td`k'_`h'>0 & cf_td`k'_`h'>0
	replace cf_td`k'_`h' = max(cf_td`k'_`h', r(min)) if d_td`k'_`h'>0 & d_td`k'_`h'<. 
	}
}      // // //
forv k1=1/21 { // Create Debt and CF for each Bank
g cf_B`k1' = 0
g d_B`k1' = 0
foreach k of numlist 1 2 5 { // Debt Type 1, 2 or 5 (Banks) - note that 4 changed to 5 in 2014
	forv h=1/3 {  // Debt number 1 to 3
	replace cf_B`k1' = cf_B`k1' + cf_td`k'_`h' if cf_td`k'_`h'<. & `fD`yr''_t`k'd`h'==`k1'
	replace d_B`k1' = d_B`k1' + max(d_td`k'_`h', cf_td`k'_`h') if d_td`k'_`h'<. & `fD`yr''_t`k'd`h'==`k1'
	}
} 
}
forv k1=1/10 { // Create Debt and CF for each Retail Store
g cf_R`k1' = 0
g d_R`k1' = 0
foreach k of numlist 3 4 { // Debt Type 3 or 5 (Retail) - 5 changed to 4 in 2014
	forv h=1/3 {  // Debt number 1 to 3
	replace cf_R`k1' = cf_R`k1' + cf_td`k'_`h' if cf_td`k'_`h'<. & `fD`yr''_t`k'd`h'==`k1'
	replace d_R`k1' = d_R`k1' + max(d_td`k'_`h', cf_td`k'_`h') if d_td`k'_`h'<. & `fD`yr''_t`k'd`h'==`k1'
	}
} 
}    
keep folio cf_B* d_B* cf_R* d_R*
rename folio folio_efh
g year_efh=20`yr'
save "$path4b\efh_`yr'_cbanks.dta", replace
}     //       //     join all years
foreach yr of numlist 10 11 14 {
joinby folio year_efh using "$path4b\efh_`yr'_cbanks.dta", unmatched(both) update
tab _merge
drop _merge
} 
if ${retail_op}==1 {    /*  */
replace cf_B15 = cf_B15+cf_R1  // Falabella total
replace cf_B16 = cf_B16+cf_R3  // Ripley total
replace cf_B18 = cf_B18+cf_R2  // Paris total
replace d_B15 = d_B15+d_R1  // Falabella total
replace d_B16 = d_B16+d_R3  // Ripley total
replace d_B18 = d_B18+d_R2 // Paris total 
} // 1. BANCO DE CHILE  2. ATLAS 3. ESTADO 4. SCOTIABANK 5. DESARROLLO 6. BANCO DE CREDITO E INVERSIONES (BCI) 7. BCI NOVA (CONOSUR) 8. CORPBANCA   
sort year_efh folio_efh // 9. CONDELL  10. BICE  11. SANTANDER  12. BANEFE  13. ITAU 14. SECURITY 15. FALABELLA 16. RIPLEY (SANTIAGO EXPRESS)
order folio_efh year_efh, first //  17. PENTA 18. PARIS 19. BANCO BILBAO VIZCAYA ARGENTARIA (BBVA) 20. BBVA EXPRESS  21. Otro
foreach k of numlist 1 4 6 8 11 19 { //Group Banks: ATLAS=Chile Desarrollo=SCOTIA BCI NOVA=BCI Condell=CorpBanca BANEFE=Santander BBVA Express=BBVA 
local k2 = `k'+1         // Others Penta=Otro
replace cf_B`k' = max(0,cf_B`k') +  max(0,cf_B`k2')
replace d_B`k' = max(0,d_B`k') +  max(0,d_B`k2')
drop cf_B`k2' d_B`k2'
}
replace cf_B13 = max(0,cf_B8) +  max(0,cf_B13)  // Itau-Corpbanca fusion
replace d_B13 = max(0,d_B8) +  max(0,d_B13)
drop cf_B8 d_B8   
save "$path4b\efh_CDebt_Bid.dta", replace
