global Rsigma = r(sd)*sqrt(12) // Agarwal et al JMCB 2013: mortgage sigma = 0.0109
global rho = 0.05 // the real discount rate (Agarwal et al JMCB 2013)
global Fcost = ${BPP} // fixed cost of renegotiating in UF: 20 or 24 or 24.1
global fpc=0.01  // variable cost of renegotiating
global miuADL = 0.05 // Agarwal et al 2013: miu=10% (page 13). Hayre et al (2000) estimate that 5–7% of single-family homes turnover per year.
global thetaADL = ${miuADL}+0.01   // probability of exogenous refinancing (Agarwal et al 2013: use 10% or miu + 10%)
global Nmyears = 20   // number of years of new mortgage (mode in Chile EFH: 46% of the loans)
global infR = 0.03  // Inflation rate target of Central Bank of Chile
global RMop = 1 // Contracts are in Real terms
local GDP17 =  179749*(1000^3)/26799   // PIB 2017  179749*(1000^3)  // 26572 (UF 2017 or 26799 by end Dec-2017)
local sop1 = "replace"  // 4.0 - Join all the EFH data then estimate logit models of Renegotiation plus Counterfactuals
local sop2 = "append"
capture log close

use "$path4b\\TSmpr.dta", clear
egen time=group(year month)
tsset time
g dRm = L.MPRate
replace dRm=(MPRate-dRm)   
sum MPRate dRm, d
sum MPRate dRm if year>=2007, d    // 3.5%, 2.5%, 1.25%, 0.5%
sum MPRate dRm if year==2017     // 

use "$path4b\TSRates.dta", clear // 1.0 Compute calibration parameters for renegotiation formula of Agarwal et al JMCB 2013
sort year month
egen time=group(year month)
tsset time
g dRm = L.Rmortgage
replace dRm=(Rmortgage-dRm)   //   Already divided now! /100  //g Rmortgage_adl=Rmortgage/100
sum Rmortgage dRm if year>=2003, d //sum Rmortgage_adl if year>=2003, d     // 4.3%, 3.6%, 2%
sum Rmortgage dRm if year==2017 

use "$path4b\\Rene_EFHall.dta", clear  // sum xPV* // Rene_EFHall0.dta
sum ${iEfin} [fw=factor_all], d
local iS = r(sd)
local iS1 = 0.25*`iS'
local iS2 = 0.50*`iS'
local iS3 = 0.75*`iS'
local iS4 = `iS'
display(`iS')
g nr_pays_done = (year_efh-yrCMortg_VIV)*12 - max(1,mCMortg_VIV)  + 7 if yrCMortg_VIV>=1975 
g nr_paysC = 12*yrMatCMortg_VIV
replace nr_pays_done=. if nr_pays_done<=0
replace nr_pays_done=. if nr_pays_done>=nr_paysC
replace nr_pays_done=0 if nr_pays_done==.

g Mny = (yrMatCMortg_VIV*12 -nr_pays_done)/12 
sum Ideuda* taxtau RCmortg_VIV Mny
local cf=""
local rf="xADL"
local k=1
g iCv = ${iEfin}
g m_`rf' = m`cf'_`rf'_VIV 
local RV2 = "m_xADL rci_pend_75 iCv" 
logit RenMortg_VIV `RV2' i.(year_efh) 
local Rm = 0.035
replace RCmortg_VIV = max(RCmortg_efh, RCmortg_VIV)
replace Ideuda_VIV=exp(Ideuda_VIV)
local Ib = "Hip_"
local k=2
local Prop="VIV"
replace `Ib'difALL_`Prop' = `Ib'difALL_`Prop' + `Ib'Rorig`k'_`Prop'
foreach b of numlist 1/4 {
replace `Ib'B`b'_difALL_`Prop' = `Ib'B`b'_difALL_`Prop' + `Ib'Rorig`k'_`Prop'
rename `Ib'B`b'_difALL_`Prop' `Ib'B`b'_difALL
}
rename `Ib'difALL_`Prop' `Ib'difALL
sum `Ib'Rorig`k'_`Prop' `Ib'difALL `Ib'B*_difALL [fw=factor_all]  // `Ib'difALL_`Prop' `Ib'B*_difALL_`Prop' // `Ib'Rcf`k'_`Prop' 
foreach cf in "" "A" { 
global Fcost = ${`cf'PP} 
refinance_ADLoption Ideuda_`Prop' taxtau RCmortg_`Prop' Mny 250
refinance_ADLsqroot Ideuda_`Prop' taxtau RCmortg_`Prop' Mny  
refinance_PVbreakeven Ideuda_`Prop' taxtau RCmortg_`Prop' Mny
replace xADL=max(xSqr,xADL) 
replace xSqr=max(xSqr,xPV)   //foreach rf in "xADL" "xSq" "xPV" {  replace m`cf'_`rf'_`Prop'=1+m`cf'_`rf'_`Prop' if Ideuda>0 & Ideuda<. & dif>0 & Adif>`rf'  } 
rename xADL xADL_`cf'
rename xSqr xSqr_`cf'
rename xPV xPV_`cf'
}  /**/   //foreach rf in "xADL" "xSq" "xPV" {  g Dr`cf'_`rf'_`Prop'= (m`cf'_`rf'_`Prop'>0) if Ideuda_`Prop'>0 & Ideuda_`Prop'<.  }
sum Dr_*VIV DrA_*VIV
sum xADL* xSqr* xPV*

foreach Rm of numlist 0.035 0.025 0.0125 0.0050 {
local Rm2 = floor(10000*`Rm')

foreach cf in "" "A" { // *foreach b of numlist 1/4 {      *replace iCv = ${iEfin} + `iS`b''
global Fcost = ${`cf'PP}      // *replace m_`rf' = m`cf'_`rf'_`Prop'    *replace PV`k'_`rf' = PV`k'`cf'_`rf'_`Prop'
refinance_PVgain Ideuda_VIV taxtau RCmortg_VIV Mny `Rm'  
refinance_PVgain2 Ideuda_VIV taxtau RCmortg_VIV Mny `Rm'   
g PV`cf'_`Rm2'=max(0,xPVgain1,xPVgain2)   // PV_`Rm2'_ed`b' // exp(PV1`cf'_`rf'_`Prop')  exp(PV1A_`rf'_`Prop') 
drop xPVgain*
}

g `Ib'Rorig_`Rm2' = `Ib'Rorig`k'_`Prop'*PV_`Rm2'    //exp(PV1`cf'_`rf'_`Prop') // Multiply probability of renegotiation mortgage with gain (before the law)
foreach var1 of varlist `Ib'difALL `Ib'B*_difALL {   // `Ib'Rcf`k'_`Prop' `Ib'difALL_`Prop' `Ib'B*_difALL_`Prop'
g `var1'_`Rm2' = `var1'*PVA_`Rm2'     //exp(PV1A_`rf'_`Prop') // Multiply probability of renegotiation mortgage with gain (after the law)
}
g dif = RCmortg_`Prop'-`Rm'
g `Ib'ADL_`Rm2' = (dif>xADL_A)   
replace `Ib'ADL_`Rm2'=`Ib'ADL_`Rm2'*PVA_`Rm2'
drop dif
}
sum PV_* PVA_* [fw=factor_all] 
sum `Ib'Rorig`k'_`Prop' `Ib'difALL `Ib'B*_difALL
drop *_vp *_OTP
g young_middle_old = edad
recode young_middle_old 0/34=1 35/64=2 65/.=3
keep folio* year_efh pop quintile_h Estrato_VIV educ_ecf ${iEfin} tr_edad2 edad young_middle_old factor_all ///
 `Ib'Rorig_* `Ib'difALL_* `Ib'B1_difALL_* `Ib'B2_difALL_* `Ib'B3_difALL_* `Ib'B4_difALL_* `Ib'ADL_*
save "$path4b\\Rene_EFHall00.dta", replace
collapse (sum) `Ib'Rorig_* `Ib'difALL_* `Ib'B1_difALL_* `Ib'B2_difALL_* `Ib'B3_difALL_* `Ib'B4_difALL_* `Ib'ADL_* [fw=factor_all]
g young_middle_old = 0
reshape long `Ib'Rorig_ `Ib'difALL_ `Ib'B1_difALL_ `Ib'B2_difALL_ `Ib'B3_difALL_ `Ib'B4_difALL_ `Ib'ADL_, i(young_middle_old) j(MRate)
save "$path4b\\data_temp.dta", replace

use "$path4b\\Rene_EFHall00.dta", clear
collapse (sum) `Ib'Rorig_* `Ib'difALL_* `Ib'B1_difALL_* `Ib'B2_difALL_* `Ib'B3_difALL_* `Ib'B4_difALL_* `Ib'ADL_* [fw=factor_all], by(young_middle_old)
reshape long `Ib'Rorig_ `Ib'difALL_ `Ib'B1_difALL_ `Ib'B2_difALL_ `Ib'B3_difALL_ `Ib'B4_difALL_ `Ib'ADL_, i(young_middle_old) j(MRate)
joinby young_middle_old using "$path4b\\data_temp.dta", unmatched(both) update
tab _merge
drop _merge
foreach var1 of varlist Hip_Rorig_-Hip_B4_difALL_ `Ib'ADL_ {
replace `var1' = `var1'/`GDP17'
}
save "$path4b\\data_temp.dta", replace
export excel using "$path_t\\\MPolicy_age.xlsx", firstrow(variables) nolabel replace 
