clear all
capture log close
global path0 "C:\DAT\\EFH\"
global path_bs_do "$path0\Proyectos\2010_Household Risk\"
global path_bs_do2 "$path0\Proyectos\2020_PFin\"
global path4b "$path_bs_do2\data\"
global path_g "C:\Docs2\EFH_CDI\PFinanciera\graphs\"
global path_t "C:\Docs2\EFH_CDI\PFinanciera\tables\"
global factor17 "factor_egm"
global factor14 "factor_egm"
global factor11 "factor_cvars1112"
global factor10 "factor_cvars11112_vs3"
global factor09 "factor_cvars1112"
global factor08 "factor_ec_vars1112"
global factor07 "expr0531m"
global retail_op = 1
global PP = 24.1 // before Portabilidad Financiera: 20 or 24 or 24.1
global BPP = 24.1 // before Portabilidad Financiera: 20 or 24 or 24.1
global APP = 8.7 // after Portabilidad Financiera: 9 or 9.75 or 8.7
global iEfin "i2EducFin"   // iEducFin i2EducFin

// 0 - Algorithms
run "$path_bs_do\household_risk\empleo\mean_wgts2.do" 
run "$path_bs_do2\lambert_w" 
run "$path_bs_do2\lambert_w_integral" 
run "$path_bs_do2\refinance_npvKost" 
run "$path_bs_do2\refinance_Rlambda" 
run "$path_bs_do2\refinance_ADLoption" 
run "$path_bs_do2\refinance_ADLoptionMonthly" 
run "$path_bs_do2\refinance_PVbreakeven"
run "$path_bs_do2\refinance_PVgain"  
run "$path_bs_do2\refinance_PVgain2"  
run "$path_bs_do2\refinance_ADLsqroot"   //do "$path_bs_do2\test.do" // Test functions in Agarwal et al. (2013): great! it works!

// 1 - Format data
do "$path_bs_do2\format_EA" // Atkinson and Messy (2012) indexes of Financial Literacy: financial knowledge, financial behavior, financial attitudes
run "$path_bs_do2\format_R_tseries" // 1.0 - Time series of bank interest rates
run "$path_bs_do2\format_DFVP_Ld.do" // Create dummies for Mortgage default and dummies for Lender type
run "$path_bs_do2\format_BancoIDtasa.do" 
run "$path_bs_do2\format_EFH_renegotiation" // 2.0 - Format EFH mortgage contracts data
run "$path_bs_do2\compute_Mrenegotiation" // 3.0 - Compute Agarwal et al measures for each mortgage loan since the beginning of the contract
run "$path_bs_do2\combine_EFH_SLO_BalSheet.do" 
run "$path_bs_do2\EFH_10_11.do" //  Consumer bank ids for EFH 2010 and 2011
run "$path_bs_do2\EFH_14_17.do" 


// 2 - Regressions and analysis
do "$path_bs_do2\analysis_RenegHip_ADL.do" 
do "$path_bs_do2\tables_TaxR_LawGains.do" 
do "$path_bs_do2\tables_efh_ecf.do" 
do "$path_bs_do2\RobChecks_RenegHip.do" 
do "$path_bs_do2\MPolicy_counterfactual.do"

// 3 - Bank switching analysis
run "$path_bs_do2\Panel_EFH.do" 
do "$path_bs_do2\analysis_CBankSwitching.do" 
