local sop1 = "replace"  // 4.0 - Join all the EFH data then estimate logit models of Renegotiation plus Counterfactuals
local sop2 = "append"
capture log close
local GDP17 =  179749*(1000^3)/26799   // PIB 2017  179749*(1000^3)  // 26572 (UF 2017 or 26799 by end Dec-2017)

use "$path4b\\Rene_EFHall0.dta", clear
sum ${iEfin} [fw=factor_all], d
local iS = r(sd)
local iS1 = 0.25*`iS'
local iS2 = 0.50*`iS'
local iS3 = 0.75*`iS'
local iS4 = `iS'
display(`iS')
local cf=""
local rf="xADL"
local k=1
putexcel set "$path_g\\no_bank_vars\\RenHipLogit_R2_RCs.xls", replace
foreach Prop in "VIV" "vp" "OTP" "otp1" { //  "otp2" "otp3" 
g iCv = ${iEfin} // ln(${iEfin})
g m_`rf' = orm`cf'_`rf'_`Prop'    //local RV1 = "m_`rf' Ideuda_`Prop' Rdif_`Prop'" 
g PV`k'_`rf' = orPV`k'`cf'_`rf'_`Prop'  // local RV1 = "Dr`cf'_`rf'_`Prop' PV`k'`cf'_`rf'_`Prop' Ideuda_`Prop' Rdif`cf'_`Prop'"
g iCv_m = iCv*m_`rf'  // Ideuda_`Prop' // local RV2 = "PV`k'_`rf' Ideuda_`Prop' Rdif_`Prop'" 
g iCv_PV = iCv*PV`k'_`rf' //local RV3 = "Dr`cf'_`rf'_`Prop' PV`k'`cf'_`rf'_`Prop'"

g dumPV`k'_`rf' = (PV`k'_`rf'>0)
g lnPV`k'_`rf' = max(0, ln(PV`k'_`rf'))
g rPV`k'_`rf' = PV`k'_`rf' / (ytot_p_h/uf_yrq4)
g LNm_`rf' =  max(0,ln(m_`rf'))  //max(0,m_`rf')
g LNy = max(0, ln(ytot_p_h/uf_yrq4))
g ln2PV`k'_`rf' = lnPV`k'_`rf' ^ 2
g iCv_m2 = iCv*LNm_`rf'
g iCv_PV2 = iCv*lnPV`k'_`rf'

local RV1 = "LNm_`rf' lnPV`k'_`rf' ln2PV`k'_`rf' rci_pend_75 iCv" //"LNm_`rf' lnPV`k'_`rf' ln2PV`k'_`rf' rci_pend_75 iCv iCv_m2 iCv_PV2 LNy"  //   //"dumPV`k'_`rf' m_`rf' PV`k'_`rf' rci_pend_75 iCv"   // Table 3       // "m_`rf' PV`k'_`rf' rci_pend_75 iCv"
local RV2 = "LNm_`rf' lnPV`k'_`rf' ln2PV`k'_`rf' rci_pend_75 iCv iCv_m2 LNy" //"dumPV`k'_`rf' m_`rf' lnPV`k'_`rf' rci_pend_75 iCv" 
local RV3 = "dumPV`k'_`rf' m_`rf' rPV`k'_`rf' rci_pend_75 iCv"  //  //"LNm_`rf' lnPV`k'_`rf' ln2PV`k'_`rf' rci_pend_75 iCv iCv_PV2 LNy" //"dumPV`k'_`rf' m_`rf' rPV`k'_`rf' rci_pend_75 iCv"
local RV4 = "LNm_`rf' lnPV`k'_`rf' ln2PV`k'_`rf' rci_pend_75 iCv"   //"dumPV`k'_`rf' LNm_`rf' lnPV`k'_`rf' rci_pend_75 iCv LNy"        
local RV5 = "LNm_`rf' lnPV`k'_`rf' rci_pend_75 iCv LNy"        
local RV6 = "LNm_`rf' lnPV`k'_`rf' ln2PV`k'_`rf' rci_pend_75 iCv LNy"        

local Bvars = "act_tot_`Prop' roa_`Prop' i.(cluster_`Prop')"  // roe_`Prop'
local SDvars = "Hip_Oacum_vintage_`Prop' Hip_Dacum_vintage_`Prop'"
putexcel set "$path_g\\no_bank_vars\\RenHipLogit_R2_RCs.xls", sheet(`Prop', replace) modify
putexcel A1="R2"
forv kv=1/6 {  // 1/6    Table 3: 1/3 is without interactions, Table 4: 4/6 is with interactions
replace m_`rf' = m`cf'_`rf'_`Prop'
replace PV`k'_`rf' = PV`k'`cf'_`rf'_`Prop'
replace iCv = ${iEfin}
replace iCv_m = iCv*m_`rf' 
replace iCv_PV = iCv*PV`k'_`rf' 
local k2=min(2,`kv')

log using "$path_g\\no_bank_vars\RenegMregs_`Prop'_RCs.log", `sop`k2'' 
logit RenMortg_`Prop' `RV`kv'' i.(year_efh) 
outreg2 using "$path_g\\\no_bank_vars\\RenHipLogit_`Prop'_RCs.xls", `sop`k2''   // no predict

putexcel A`kv'=`e(r2_p)'
predict Hip_Rorig`kv'_`Prop' if RenMortg_`Prop'<.  // Baseline
replace m_`rf' = mA_`rf'_`Prop'
replace PV`k'_`rf' = PV`k'A_`rf'_`Prop'
predict Hip_Rcf`kv'_`Prop' if RenMortg_`Prop'<.   // Counterfactual
foreach b of numlist 1/4 {
replace iCv = ${iEfin} + `iS`b''
replace iCv_m = iCv*m_`rf' 
replace iCv_PV = iCv*PV`k'_`rf' 
predict Hip_B`b'_Rcf`kv'_`Prop' if RenMortg_`Prop'<.  // Counterfactual
}
replace m_`rf' = m`cf'_`rf'_`Prop'
replace PV`k'_`rf' = PV`k'`cf'_`rf'_`Prop'
replace iCv = ${iEfin}
replace iCv_m = iCv*m_`rf' 
replace iCv_PV = iCv*PV`k'_`rf' 
margins, dydx(`RV`kv'') atmeans post 
outreg2 using "$path_g\no_bank_vars\MEff_RenHipLogit_`Prop'_RCs.xls", `sop`k2''
log close

log using "$path_g\RenegMregs_`Prop'_RCs.log", `sop`k2''   // Table 5: Bank characteristic regressions
logit RenMortg_`Prop' `RV`kv'' `Bvars' `SDvars' i.(year_efh) if cluster_`Prop'>=11
outreg2 using "$path_g\\RenHipLogit_`Prop'_RCs.xls", `sop`k2''
putexcel B`kv'=`e(r2_p)'
predict Rorig`kv'_`Prop' if RenMortg_`Prop'<. & cluster_`Prop'>=11 // Baseline
replace m_`rf' = mA_`rf'_`Prop'
replace PV`k'_`rf' = PV`k'A_`rf'_`Prop'
predict Rcf`kv'_`Prop' if RenMortg_`Prop'<. & cluster_`Prop'>=11 // Counterfactual
foreach b of numlist 1/4 {
replace iCv = ${iEfin} + `iS`b''
replace iCv_m = iCv*m_`rf' 
replace iCv_PV = iCv*PV`k'_`rf' 
predict B`b'_Rcf`kv'_`Prop' if RenMortg_`Prop'<. & cluster_`Prop'>=11 // Counterfactual
}
replace m_`rf' = m`cf'_`rf'_`Prop'
replace PV`k'_`rf' = PV`k'`cf'_`rf'_`Prop'
replace iCv = ${iEfin}
replace iCv_m = iCv*m_`rf' 
replace iCv_PV = iCv*PV`k'_`rf' 
margins, dydx(`RV`kv'') atmeans post 
outreg2 using "$path_g\\MEff_RenHipLogit_`Prop'_RCs.xls", `sop`k2''
log close

}   // End of Baseline plus Counterfactual
drop m_`rf' PV`k'_`rf' iCv iCv_m iCv_PV dumPV`k'_`rf' lnPV`k'_`rf' rPV`k'_`rf' LNm_`rf' LNy ln2PV`k'_`rf' iCv_m2 iCv_PV2
}    //      //      //
foreach Ib in "" "Hip_" { // `Ib'
foreach Prop in "VIV" "vp" "OTP" { 
forv k=1/6 { 
replace `Ib'Rcf`k'_`Prop' = max(`Ib'Rorig`k'_`Prop',`Ib'Rcf`k'_`Prop') 
g `Ib'dif`k'_`Prop' = `Ib'Rcf`k'_`Prop' - `Ib'Rorig`k'_`Prop'
foreach b of numlist 1/4 {
replace `Ib'B`b'_Rcf`k'_`Prop' = max(`Ib'Rorig`k'_`Prop',`Ib'B`b'_Rcf`k'_`Prop') 
g `Ib'B`b'_dif`k'_`Prop' = `Ib'B`b'_Rcf`k'_`Prop' - `Ib'Rorig`k'_`Prop'
}       
}  //egen RoAll_`Prop'=rowmin(Rorig*_`Prop') egen RcfALL_`Prop'=rowmax(Rcf*_`Prop') egen B`b'_RcfALL_`Prop'=rowmax(B`b'_Rcf*_`Prop') 
egen `Ib'difALL_`Prop' = rowmax(`Ib'dif*_`Prop')
foreach b of numlist 1/4 {
egen `Ib'B`b'_difALL_`Prop' = rowmax(`Ib'B`b'_dif*_`Prop')
} 
}   // Measures 1 to 6 are somewhat similar: use only measures 2 and 5
}
save "$path4b\\Rene_EFHall_RCs.dta", replace

local RV1 = "pop"  // 5.0 - Summarize Baseline and Counterfactuals of Portabilidad Financiera
local RV2 = "quintile_h"
local RV3 = "Estrato_VIV"
local RV4 = "Estrato_vp"
local RV5 = "Estrato_OTP"
local RV6 = "educ_ecf"
quietly { 
foreach Ib in "" "Hip_" { 
forv kv=1/6 {
use "$path4b\\Rene_EFHall_RCs.dta", clear     //RoAll* RcfALL* // RoAll* B1_RcfALL* B2_RcfALL* 
drop *otp1 *otp2 *otp3  
local k=3
foreach Prop in "VIV" "vp" "OTP" { 
replace `Ib'difALL_`Prop' = `Ib'difALL_`Prop' + `Ib'Rorig`k'_`Prop'
foreach b of numlist 1/4 {
replace `Ib'B`b'_difALL_`Prop' = `Ib'B`b'_difALL_`Prop' + `Ib'Rorig`k'_`Prop'
}
foreach var1 of varlist `Ib'Rorig`k'_`Prop' `Ib'Rcf`k'_`Prop' `Ib'difALL_`Prop' `Ib'B*_difALL_`Prop' {
replace `var1' = . if cluster_`Prop'==1
}
} // `Ib'Rcf`k'*  `Ib'B1_Rcf`k'* `Ib'B2_Rcf`k'* //`Ib'B*_difALL_*
collapse `Ib'Rorig`k'* `Ib'difALL_* `Ib'B1_difALL_* `Ib'B2_difALL_* `Ib'B3_difALL_* `Ib'B4_difALL_* [fw=factor_all], by(`RV`kv'')   
export excel using "$path_t\\counterfactuals_RenM\\`Ib'\\RenHip_OrCf_`RV`kv''_RCs.xlsx", firstrow(variables) nolabel replace 
/*use "$path4b\\Rene_EFHall_RCs.dta", clear
drop *otp1 *otp2 *otp3  
local k=5
foreach Prop in "VIV" "vp" "OTP" { 
replace `Ib'difALL_`Prop' = `Ib'difALL_`Prop' + `Ib'Rorig`k'_`Prop'
foreach b of numlist 1/4 {
replace `Ib'B`b'_difALL_`Prop' = `Ib'B`b'_difALL_`Prop' + `Ib'Rorig`k'_`Prop'
}
foreach var1 of varlist `Ib'Rorig`k'_`Prop' `Ib'Rcf`k'_`Prop' `Ib'difALL_`Prop' `Ib'B*_difALL_`Prop' {
replace `var1' = . if cluster_`Prop'==1
}
}
collapse `Ib'Rorig`k'* `Ib'difALL_* `Ib'B1_difALL_* `Ib'B2_difALL_* `Ib'B3_difALL_* `Ib'B4_difALL_* [fw=factor_all], by(`RV`kv'')
export excel using "$path_t\\counterfactuals_RenM\\`Ib'\\ICdif_RenHip_OrCf_`RV`kv''_RCs.xlsx", firstrow(variables) nolabel replace */
}
}
}
clear 

local RV1 = "pop"  // 1.0: Welfare gains from renegotiation in Present Value times Probability of Renegotiating Mortgages
local RV2 = "quintile_h"
local RV3 = "Estrato_VIV"
local RV4 = "Estrato_vp"
local RV5 = "Estrato_OTP"
local RV6 = "educ_ecf"
local cf=""
local rf="xADL"  //local k=1   // use the PV formula of ADL
quietly { 
foreach Ib in "" "Hip_" { 
forv kv=1/6 {
use "$path4b\\Rene_EFHall_RCs.dta", clear   
drop *otp1 *otp2 *otp3  
local k=3
foreach Prop in "VIV" "vp" "OTP" { 
replace `Ib'difALL_`Prop' = `Ib'difALL_`Prop' + `Ib'Rorig`k'_`Prop'
foreach b of numlist 1/4 {
replace `Ib'B`b'_difALL_`Prop' = `Ib'B`b'_difALL_`Prop' + `Ib'Rorig`k'_`Prop'
}
foreach var1 of varlist `Ib'Rorig`k'_`Prop' `Ib'Rcf`k'_`Prop' `Ib'difALL_`Prop' `Ib'B*_difALL_`Prop' {
replace `var1' = . if cluster_`Prop'==1
}
foreach var1 of varlist `Ib'Rorig`k'_`Prop' { // Multiply probability of renegotiation mortgage with gain (before the law)
replace `var1' = `var1'*exp(PV1`cf'_`rf'_`Prop')  // Note - variable had previously been put in log
}
foreach var1 of varlist `Ib'Rcf`k'_`Prop' `Ib'difALL_`Prop' `Ib'B*_difALL_`Prop' {
replace `var1' = `var1'*exp(PV1A_`rf'_`Prop') // Multiply probability of renegotiation mortgage with gain (after the law)
}    //    //    //
} 
keep folio* year_efh pop quintile_h Estrato_VIV Estrato_vp Estrato_OTP educ_ecf ${iEfin} tr_edad2 edad factor_all constant ///
 `Ib'Rorig`k'* `Ib'difALL_* `Ib'B1_difALL_* `Ib'B2_difALL_* `Ib'B3_difALL_* `Ib'B4_difALL_*
save "$path4b\\data_temp.dta", replace
collapse (sum) constant (mean) `Ib'Rorig`k'* `Ib'difALL_* `Ib'B1_difALL_* `Ib'B2_difALL_* `Ib'B3_difALL_* `Ib'B4_difALL_* [fw=factor_all], by(`RV`kv'')   
export excel using "$path_t\\counterfactuals_RenM\\`Ib'\\PV_RenHip_OrCf_`RV`kv''_RCs.xlsx", firstrow(variables) nolabel replace 
foreach Prop in "VIV" "vp" "OTP" { 
foreach var1 of varlist `Ib'difALL_`Prop' `Ib'B*_difALL_`Prop' {
replace `var1' = `var1' - `Ib'Rorig`k'_`Prop' 
g GDP_`var1' = constant*`var1'/`GDP17'
}    //    //    //
}
export excel using "$path_t\\counterfactuals_RenM\\`Ib'\\WGains_`RV`kv''_RCs.xlsx", firstrow(variables) nolabel replace 
/*use "$path4b\\Rene_EFHall_RCs.dta", clear
drop *otp1 *otp2 *otp3  
local k=5
foreach Prop in "VIV" "vp" "OTP" { 
replace `Ib'difALL_`Prop' = `Ib'difALL_`Prop' + `Ib'Rorig`k'_`Prop'
foreach b of numlist 1/4 {
replace `Ib'B`b'_difALL_`Prop' = `Ib'B`b'_difALL_`Prop' + `Ib'Rorig`k'_`Prop'
}
foreach var1 of varlist `Ib'Rorig`k'_`Prop' `Ib'Rcf`k'_`Prop' `Ib'difALL_`Prop' `Ib'B*_difALL_`Prop' {
replace `var1' = . if cluster_`Prop'==1
}
foreach var1 of varlist `Ib'Rorig`k'_`Prop' { // Multiply probability of renegotiation mortgage with gain (before the law)
replace `var1' = `var1'*exp(PV1`cf'_`rf'_`Prop') // Note - variable had previously been put in log
}
foreach var1 of varlist `Ib'Rcf`k'_`Prop' `Ib'difALL_`Prop' `Ib'B*_difALL_`Prop' {
replace `var1' = `var1'*exp(PV1A_`rf'_`Prop') // Multiply probability of renegotiation mortgage with gain (after the law)
}    //    //    //
}
collapse `Ib'Rorig`k'* `Ib'difALL_* `Ib'B1_difALL_* `Ib'B2_difALL_* `Ib'B3_difALL_* `Ib'B4_difALL_* [fw=factor_all], by(`RV`kv'')
export excel using "$path_t\\counterfactuals_RenM\\`Ib'\\PV_ICdif_RenHip_OrCf_`RV`kv''_RCs.xlsx", firstrow(variables) nolabel replace */
}
}
}
clear 
