use "$path4b\efhPanel_11_14_17.dta", clear  // local vlV "ing rda debt_pi_ratio rci_pend_75 numh edad hombre_casado genero instituto 
tab year_efh       // universidad unemp_sect sexo educ_ecf" // act_tot_* roa_*
drop *cf_R* *d_R*  
egen iEducFin = rowmax(Yr*_iEducFin)  
egen i2EducFin = rowmax(Yr*_i2EducFin)  
egen educ_ecf = rowmax(Yr*_educ_ecf)
egen quintile_h = rowmax(Yr*_quintile_h)
egen c_hip = rowmin(Yr*_c_hip )
local cf=""
local rf="xADL"
local k=1
local Prop = "VIV" 
egen m_xADL_VIV = rowmin(Yr*_m`cf'_`rf'_`Prop' )
egen PV1_xADL_VIV = rowmin(Yr*_PV1_xADL_VIV)   //replace PV1_xADL_VIV = max(0, ln(PV1_xADL_VIV))
g Yr0_ln_dna = max(0, ln(Yr0_d_dna) )
g Yr0_ln_dhip = max(0, ln(Yr0_dhip) )
egen Yr0_cfB = rowtotal(Yr0_cf_B*) // 1=Chile 3=Estado 4=SCOTIA 6=BCI 10=BICE 11=Santander 13+8=Itau,CorpBanca 14=SECURITY 15=FALABELLA 16=RIPLEY
egen Yr1_cfB = rowtotal(Yr1_cf_B*)  // 17=PENTA 18=PARIS 19=BANCO BILBAO VIZCAYA ARGENTARIA (BBVA) 21=Otro
g Yr0_nrBanks = 0
g Yr1_nrBanks = 0
g Yr0_MainB = .
g Yr1_MainB = .
egen Yr0_largestDebt = rowmax(Yr0_d_B*)
egen Yr1_largestDebt = rowmax(Yr1_d_B*)
foreach Prop in "VIV" "vp" "OTP" { 
recode Yr0_Hbancofin_`Prop' 8/9=13 2=1 5=4 7=6 12=11 20=19
recode Yr1_Hbancofin_`Prop' 8/9=13 2=1 5=4 7=6 12=11 20=19
}
replace Yr0_RenMortg_VIV=0 if Yr0_RenMortg_VIV==.
egen RenMortg_VIV = rowmax(Yr*_RenMortg_VIV)
foreach k of numlist 1 3 4 6 10 11 13/19 21 { 
g switchB`k' = (Yr1_cf_B`k'<=0) if Yr0_cfB>0 & Yr1_cfB>0 & Yr0_cf_B`k'>0 & Yr0_cf_B`k'<.
g switchBm`k' = (Yr1_cf_B`k'<=0) if Yr1_cfB>0 & Yr0_Hbancofin_VIV==`k' & Yr1_Hbancofin_VIV!=`k'
replace switchBm`k' = 1 if Yr1_cf_B`k'<=0 & Yr1_cfB>0 & Yr0_Hbancofin_vp==`k' & Yr1_Hbancofin_VIV!=`k'
replace switchBm`k' = 1 if Yr1_cf_B`k'<=0 & Yr1_cfB>0 & Yr0_Hbancofin_OTP==`k' & Yr1_Hbancofin_VIV!=`k'
foreach y of numlist 0 1  { 
replace Yr`y'_nrBanks = Yr`y'_nrBanks+1 if Yr`y'_cf_B`k'>0 & Yr`y'_cf_B`k'<.
replace Yr`y'_MainB = `k' if Yr`y'_d_B`k'>=Yr`y'_largestDebt &  Yr`y'_d_B`k'<.
} 
} 
foreach Prop in "VIV" "vp" "OTP" { 
foreach k of numlist 1 3 4 6 10 11 13/19 21 { 
foreach y of numlist 0 1  { 
replace Yr`y'_MainB = `k' if Yr0_Hbancofin_`Prop'==`k' & Yr`y'_MainB==.
replace Yr`y'_MainB = `k' if Yr1_Hbancofin_`Prop'==`k' & Yr`y'_MainB==.
}
}
}
g Yr0_MainBtype = Yr0_MainB  // type 1 Large: Chile, Estado, BCI, Santander. type 2 Retail: FALABELLA, Ripley, Paris. type 3 Median: BBVA, Itau/Corpb, SCOTIA
g Yr1_MainBtype = Yr1_MainB     // type 4 (small): BICE, Security, Penta, Otro
recode Yr0_MainBtype 1/3=1 6=1 11=1 15/16=2 18=2 4=3 8=3 13=3 19=3 10=4 14=4 17=4 21=4
recode Yr1_MainBtype 1/3=1 6=1 11=1 15/16=2 18=2 4=3 8=3 13=3 19=3 10=4 14=4 17=4 21=4
replace Yr0_largestDebt = ln(Yr0_largestDebt)
egen switchB=rowmax(switchB*)
replace Yr0_nrBanks = min(3,Yr0_nrBanks)  
replace Yr1_nrBanks = min(3,Yr1_nrBanks)    // Yr0_ln_dhip Yr0_iEducFin iEducFin i.(year_efh)  Yr0_c_hip Yr0_ln_dna
tab switchB [fw=factor_all]  //logit switchB iEducFin Yr0_ing Yr0_largestDebt c_hip PV1_xADL_VIV
g Universidad2 = educ_ecf
recode Universidad2 1/2=1 3=2 4/5=3
g pop=1
recode Yr0_MainB 2=1 5=4 7=6 9=8 12=11 20=19 17=21 16=15 18=15 14=21
recode Yr1_MainB 2=1 5=4 7=6 9=8 12=11 20=19 17=21 16=15 18=15 14=21
recode Yr0_MainB 4/5=13 8/9=13 13=13 19=13 10=21 
recode Yr1_MainB 4/5=13 8/9=13 13=13 19=13 10=21
foreach var of varlist Yr0_debt_pi_ratio c_hip m_xADL_VIV PV1_xADL_VIV Yr0_nrBanks Yr0_MainBtype Yr0_RenMortg_VIV RenMortg_VIV Universidad2 {
replace `var'=0 if `var'==.
}
save "$path4b\efhPanel_11_14_17.dta", replace  //sum ${iEfin} [fw=factor_all], d  local iS = r(sd) local iS1 = 0.25*`iS' local iS2 = 0.50*`iS'

putexcel set "$path_g\\CBswitch_R2.xls", replace
putexcel A1="R2"
logit switchB ${iEfin} Yr0_debt_pi_ratio c_hip m_xADL_VIV PV1_xADL_VIV Yr0_nrBanks i.(Yr0_MainBtype year_efh)
outreg2 using "$path_g\\CBswitching_panel.xls", replace
putexcel A1=`e(r2_p)'
margins, dydx(${iEfin} Yr0_debt_pi_ratio c_hip m_xADL_VIV PV1_xADL_VIV Yr0_nrBanks i.(Yr0_MainBtype year_efh)) atmeans post 
outreg2 using "$path_g\CBswitching_panel.xls", append
logit switchB ${iEfin} Yr0_debt_pi_ratio c_hip m_xADL_VIV Yr0_nrBanks i.(Yr0_MainBtype year_efh)
outreg2 using "$path_g\\CBswitching_panel.xls", append
putexcel A2=`e(r2_p)'
margins, dydx(${iEfin} Yr0_debt_pi_ratio c_hip m_xADL_VIV Yr0_nrBanks i.(Yr0_MainBtype year_efh)) atmeans post 
outreg2 using "$path_g\CBswitching_panel.xls", append
logit switchB ${iEfin} Yr0_debt_pi_ratio c_hip PV1_xADL_VIV Yr0_nrBanks i.(Yr0_MainBtype year_efh)
outreg2 using "$path_g\\CBswitching_panel.xls", append
putexcel A3=`e(r2_p)'
margins, dydx(${iEfin} Yr0_debt_pi_ratio c_hip PV1_xADL_VIV Yr0_nrBanks i.(Yr0_MainBtype year_efh)) atmeans post 
outreg2 using "$path_g\CBswitching_panel.xls", append
logit switchB ${iEfin} Yr0_debt_pi_ratio c_hip Yr0_RenMortg_VIV Yr0_nrBanks i.(Yr0_MainBtype year_efh)
outreg2 using "$path_g\\CBswitching_panel.xls", append
putexcel A4=`e(r2_p)'
margins, dydx(${iEfin} Yr0_debt_pi_ratio c_hip Yr0_RenMortg_VIV Yr0_nrBanks i.(Yr0_MainBtype year_efh)) atmeans post 
outreg2 using "$path_g\CBswitching_panel.xls", append
logit switchB iEducFin Yr0_debt_pi_ratio c_hip PV1_xADL_VIV Yr0_nrBanks i.(Yr0_MainBtype year_efh) [pw=factor_all]
logit switchB i2EducFin Yr0_debt_pi_ratio c_hip PV1_xADL_VIV Yr0_nrBanks i.(Yr0_MainBtype year_efh) [pw=factor_all]

local RV1 = "pop"  // Summary Stats
local RV2 = "quintile_h"
local RV3 = "Yr0_MainBtype"
local RV4 = "Yr0_MainB"
forv kv=1/4 {
use "$path4b\efhPanel_11_14_17.dta", clear
collapse switchB [fw=factor_all], by(RenMortg_VIV `RV`kv'')  
reshape wide switchB, i(`RV`kv'') j(RenMortg_VIV)
export excel using "$path_t\educ\Switch_Ren01_`RV`kv''.xlsx", firstrow(variables) nolabel replace 
use "$path4b\efhPanel_11_14_17.dta", clear
collapse switchB [fw=factor_all], by(Universidad2 `RV`kv'')  
reshape wide switchB, i(`RV`kv'') j(Universidad2)
export excel using "$path_t\educ\Switch_Educ_`RV`kv''.xlsx", firstrow(variables) nolabel replace 
use "$path4b\efhPanel_11_14_17.dta", clear
collapse switchB [fw=factor_all], by(`RV`kv'') 
export excel using "$path_t\educ\Switch_All_`RV`kv''.xlsx", firstrow(variables) nolabel replace 
}
clear
