local sop1 = "replace"  // 4.0 - Join all the EFH data then estimate logit models of Renegotiation plus Counterfactuals
local sop2 = "append"
local vp_otp "vivprop c_vp d_vp d_chvp  d_chotp valor_vp"  //g act_tot = 0 + 0 + vp + otp + a_auto 
local dfV "df_VPri df_VPri1M df_VSec df_VSec1M df_Vall df_V1Mall" // deuda_tot=dhip_vp +dhip_otp +dtbco+ dtcc +dcbco+ dfin+ dauto +dsocial +deduc +dotros
local vlV = "ing rda debt_pi_ratio rci_pend_75 numh edad hombre_casado genero instituto universidad unemp_sect d_z2" //local vlV3 = "ing rci_pend_75 numh edad universidad"

use "$path4b\\hist_dynamic_un06_11_dtbc.dta", clear
replace a1=(ord==1) if year_efh>=2014
keep if a1==1  //drop deuda_hip_otp1 deuda_hip_otp2 deuda_hip_otp3 deuda_hip_vp
egen y_min = rowmin(ytoth ytoth2 ytotef ytot_p_h)   //  Create indexes of financial knowledge
pwcorr y_min ytoth ytoth2 ytotef ytot_p_h
g Pc2_income = 1 if y_min<250000 
replace Pc2_income = 2 if y_min>=250000 & y_min<750000
replace Pc2_income = 3 if y_min>=750000 & y_min<1400000
replace Pc2_income = 4 if y_min>=1400000 & y_min<. //tab nive_edu //g educ_ecf = nive_edu // education_measure of ECF
g edad10y = ceil(min(74,edad)/10) //recode educ_ecf 1/4=1 5/11=2 12/13=3 14=4 15=5 16/.=1     // 1/5=1 6/12=2 13=3 14=4 15=5 16/.=1 
joinby folio_efh year_efh using "$path4b\\iEducFin_EFH.dta", unmatched(both) update
tab _merge
drop _merge    
sum edad10y sexo educ_ecf Pc2_income y_min      //    //      //    //   //    //      //    //
joinby year_efh folio_efh using "$path4b\\HipReneg4.dta", unmatched(both) update  // "$path4b\\HipReneg3.dta" "efh_DFVP_Ld.dta" "$path4b\\HipReneg2.dta"
tab _merge   //sum Ren* if _merge!=3 (extra Observations are for Time series of Mortgage Rates)  //keep if _merge==3
drop _merge  // d_chotp valor_vp dhip_vp deuda_hip_otp1 deuda_hip_otp2 deuda_hip_otp3  // pwcorr d_vp d_chvp dhip_vp
sum rD* An*
joinby year_efh folio_efh using "$path4b\efh_CDebt_Bid.dta", unmatched(master) update
tab _merge    // Note that only folios 2010 to 2017 match
drop _merge
foreach var of varlist OMortgUF* { 
replace `var'=max(0,ln(`var'))
}   // drop if yrCMortg_VIV==.   // Drop observations without year of Purchase/mortgage contract
quietly  {
replace vp=. if vp<=0
replace otp=. if otp<=0    // drop if OMortgUF_VIV<=0   |   OMortgUF_VIV==.   // Drop observations without value of Mortgage
egen viv=rowtotal(vp otp), missing
xtile Estrato_VIV=viv [fw=factor_all], nq(10)
recode Estrato_VIV 1/5=1 6/8=2 9/10=3
xtile Estrato_vp=vp [fw=factor_all], nq(10)
recode Estrato_vp 1/5=1 6/8=2 9/10=3
xtile Estrato_OTP=otp [fw=factor_all], nq(10)
recode Estrato_OTP 1/5=1 6/8=2 9/10=3
replace Estrato_VIV = max(Estrato_VIV, Estrato_VP)
replace Estrato_vp = max(Estrato_vp, Estrato_VP)
replace Estrato_OTP = max(Estrato_OTP, Estrato_2V)
}
sum dhip_vp dhip_otp deuda_hip_vp deuda_hip_otp1 deuda_hip_otp2 deuda_hip_otp3 //vivprop c_vp d_vp d_chvp  
foreach Prop in "VIV" "vp" "OTP" "otp1" "otp2" "otp3" {  // Put variables in log //
replace Ideuda_`Prop' = max(0, ln(Ideuda_`Prop')) if Ideuda_`Prop'>0 & Ideuda_`Prop'<.
foreach cf in "" "A" {  
foreach rf in "xADL" "xSq" "xPV" {  
forv k=1/2  {
g orPV`k'`cf'_`rf'_`Prop' = PV`k'`cf'_`rf'_`Prop'
replace PV`k'`cf'_`rf'_`Prop' = max(0, ln(PV`k'`cf'_`rf'_`Prop') )
}
g orm`cf'_`rf'_`Prop' = m`cf'_`rf'_`Prop'
replace m`cf'_`rf'_`Prop' = max(0, ln(m`cf'_`rf'_`Prop') )
}
}  
}   //       //      //
replace rci_pend_75= 0 if rci_pend_75==.
g pop=1
char _dta[_mi_marker]
char _dta[_mi_M]
char _dta[_mi_N]
char _dta[_mi_update]
capture drop cluster_*
foreach Prop in "VIV" "vp" "OTP" "otp1" { //  "otp2" "otp3" 
g cluster_`Prop' = Hinstitucion_`Prop' // 17=PENTA 18=PARIS 19=BANCO BILBAO VIZCAYA ARGENTARIA (BBVA) 21=Otro
g banco_type = Hbancofin_`Prop' // type 1 Large: Chile, Estado, BCI, Santander. type 2 Retail: FALABELLA, Ripley, Paris. 
recode banco_type 2=1 5=4 7=6 9=8 12=11 17=21 20=19 16=15 18=15 // type 3 Median: BBVA, Itau/Corpb, SCOTIA type 4 (small): BICE, Security, Penta, Otro
recode banco_type 1=1 3=1 6=1 11=1 15/16=2 18=2 4=3 8=3 13=3 19/20=3 10=4 14=4 17=4 21=4 //replace banco_type = 4 if banco_type==. & Hinstitucion_`Prop'==2
replace cluster_`Prop' = 10 + banco_type if banco_type>=1 & banco_type<=4  //recode cluster_new 8/9=8 .=8
drop banco_type   //foreach Prop in "VIV" "vp" "OTP" "otp1" {  foreach Prop2 in "VIV" "vp" "OTP" "otp1" { 
}  //replace cluster_`Prop' = cluster_`Prop2' if cluster_`Prop'==. & RenMortg_`Prop'<.  }  }
save  "$path4b\\EFH_ECF_all.dta", replace
drop if Ideuda_VIV==.
save "$path4b\\Rene_EFHall.dta", replace
save "$path4b\\Rene_EFHall0.dta", replace
sum ${iEfin} [fw=factor_all], d
local iS = r(sd)
local iS1 = 0.25*`iS'
local iS2 = 0.50*`iS'
local iS3 = 0.75*`iS'
local iS4 = `iS'
display(`iS')

local cf=""
local rf="xADL"
local k=1
putexcel set "$path_g\\no_bank_vars\\RenHipLogit_R2.xls", replace
foreach Prop in "VIV" "vp" "OTP" "otp1" { //  "otp2" "otp3" 
g iCv = ${iEfin} // ln(${iEfin})
g m_`rf' = m`cf'_`rf'_`Prop'    //local RV1 = "m_`rf' Ideuda_`Prop' Rdif_`Prop'" 
g PV`k'_`rf' = PV`k'`cf'_`rf'_`Prop'  // local RV1 = "Dr`cf'_`rf'_`Prop' PV`k'`cf'_`rf'_`Prop' Ideuda_`Prop' Rdif`cf'_`Prop'"
g iCv_m = iCv*m_`rf'  // Ideuda_`Prop' // local RV2 = "PV`k'_`rf' Ideuda_`Prop' Rdif_`Prop'" 
g iCv_PV = iCv*PV`k'_`rf' //local RV3 = "Dr`cf'_`rf'_`Prop' PV`k'`cf'_`rf'_`Prop'"
local RV1 = "m_`rf' PV`k'_`rf' rci_pend_75 iCv"  //local RV4 = "Ideuda_`Prop' Rdif_`Prop'"
local RV2 = "m_`rf' rci_pend_75 iCv"  
local RV3 = "PV`k'_`rf' rci_pend_75 iCv"    
local RV4 = "m_`rf' PV`k'_`rf' rci_pend_75 iCv iCv_m iCv_PV"  //  c.(iCv)#c.(m_`rf' PV`k'_`rf')
local RV5 = "m_`rf' rci_pend_75 iCv iCv_m"    // c.(iCv)#c.(m_`rf')
local RV6 = "PV`k'_`rf' rci_pend_75 iCv iCv_PV"      // c.(iCv)#c.(PV`k'_`rf')
local Bvars = "act_tot_`Prop' roa_`Prop' i.(cluster_`Prop')"  // roe_`Prop'
local SDvars = "Hip_Oacum_vintage_`Prop' Hip_Dacum_vintage_`Prop'"
putexcel set "$path_g\\no_bank_vars\\RenHipLogit_R2.xls", sheet(`Prop', replace) modify
putexcel A1="R2"
forv kv=1/6 {  // 1/6
replace m_`rf' = m`cf'_`rf'_`Prop'
replace PV`k'_`rf' = PV`k'`cf'_`rf'_`Prop'
replace iCv = ${iEfin}
replace iCv_m = iCv*m_`rf' 
replace iCv_PV = iCv*PV`k'_`rf' 
local k2=min(2,`kv')
log using "$path_g\\no_bank_vars\RenegMregs_`Prop'.log", `sop`k2'' 
logit RenMortg_`Prop' `RV`kv'' i.(year_efh) 
outreg2 using "$path_g\\\no_bank_vars\\RenHipLogit_`Prop'.xls", `sop`k2''   // no predict
putexcel A`kv'=`e(r2_p)'
predict Hip_Rorig`kv'_`Prop' if RenMortg_`Prop'<.  // Baseline
replace m_`rf' = mA_`rf'_`Prop'
replace PV`k'_`rf' = PV`k'A_`rf'_`Prop'
predict Hip_Rcf`kv'_`Prop' if RenMortg_`Prop'<.   // Counterfactual
foreach b of numlist 1/4 {
replace iCv = ${iEfin} + `iS`b''
replace iCv_m = iCv*m_`rf' 
replace iCv_PV = iCv*PV`k'_`rf' 
predict Hip_B`b'_Rcf`kv'_`Prop' if RenMortg_`Prop'<.  // Counterfactual
}
replace m_`rf' = m`cf'_`rf'_`Prop'
replace PV`k'_`rf' = PV`k'`cf'_`rf'_`Prop'
replace iCv = ${iEfin}
replace iCv_m = iCv*m_`rf' 
replace iCv_PV = iCv*PV`k'_`rf' 
margins, dydx(`RV`kv'') atmeans post // marginal effect  c.(iCv)#c.(m_`rf' PV`k'_`rf')
outreg2 using "$path_g\no_bank_vars\MEff_RenHipLogit_`Prop'.xls", `sop`k2''
log close
log using "$path_g\RenegMregs_`Prop'.log", `sop`k2''
logit RenMortg_`Prop' `RV`kv'' `Bvars' `SDvars' i.(year_efh) if cluster_`Prop'>=11
outreg2 using "$path_g\\RenHipLogit_`Prop'.xls", `sop`k2''
putexcel B`kv'=`e(r2_p)'
predict Rorig`kv'_`Prop' if RenMortg_`Prop'<. & cluster_`Prop'>=11 // Baseline
replace m_`rf' = mA_`rf'_`Prop'
replace PV`k'_`rf' = PV`k'A_`rf'_`Prop'
predict Rcf`kv'_`Prop' if RenMortg_`Prop'<. & cluster_`Prop'>=11 // Counterfactual
foreach b of numlist 1/4 {
replace iCv = ${iEfin} + `iS`b''
replace iCv_m = iCv*m_`rf' 
replace iCv_PV = iCv*PV`k'_`rf' 
predict B`b'_Rcf`kv'_`Prop' if RenMortg_`Prop'<. & cluster_`Prop'>=11 // Counterfactual
}
replace m_`rf' = m`cf'_`rf'_`Prop'
replace PV`k'_`rf' = PV`k'`cf'_`rf'_`Prop'
replace iCv = ${iEfin}
replace iCv_m = iCv*m_`rf' 
replace iCv_PV = iCv*PV`k'_`rf' 
margins, dydx(`RV`kv'') atmeans post 
outreg2 using "$path_g\\MEff_RenHipLogit_`Prop'.xls", `sop`k2''
log close
}   // End of Baseline plus Counterfactual
drop m_`rf' PV`k'_`rf' iCv iCv_m iCv_PV
}
foreach Ib in "" "Hip_" { // `Ib'
foreach Prop in "VIV" "vp" "OTP" { 
forv k=1/6 { 
replace `Ib'Rcf`k'_`Prop' = max(`Ib'Rorig`k'_`Prop',`Ib'Rcf`k'_`Prop') 
g `Ib'dif`k'_`Prop' = `Ib'Rcf`k'_`Prop' - `Ib'Rorig`k'_`Prop'
foreach b of numlist 1/4 {
replace `Ib'B`b'_Rcf`k'_`Prop' = max(`Ib'Rorig`k'_`Prop',`Ib'B`b'_Rcf`k'_`Prop') 
g `Ib'B`b'_dif`k'_`Prop' = `Ib'B`b'_Rcf`k'_`Prop' - `Ib'Rorig`k'_`Prop'
}       
}  //egen RoAll_`Prop'=rowmin(Rorig*_`Prop') egen RcfALL_`Prop'=rowmax(Rcf*_`Prop') egen B`b'_RcfALL_`Prop'=rowmax(B`b'_Rcf*_`Prop') 
egen `Ib'difALL_`Prop' = rowmax(`Ib'dif*_`Prop')
foreach b of numlist 1/4 {
egen `Ib'B`b'_difALL_`Prop' = rowmax(`Ib'B`b'_dif*_`Prop')
} 
}   // Measures 1 to 6 are somewhat similar: use only measures 2 and 5
}
save "$path4b\\Rene_EFHall.dta", replace

local RV1 = "pop"  // 5.0 - Summarize Baseline and Counterfactuals of Portabilidad Financiera
local RV2 = "quintile_h"
local RV3 = "Estrato_VIV"
local RV4 = "Estrato_vp"
local RV5 = "Estrato_OTP"
local RV6 = "educ_ecf"
quietly { 
foreach Ib in "" "Hip_" { 
forv kv=1/6 {
use "$path4b\\Rene_EFHall.dta", clear     //RoAll* RcfALL* // RoAll* B1_RcfALL* B2_RcfALL* 
drop *otp1 *otp2 *otp3  
local k=2
foreach Prop in "VIV" "vp" "OTP" { 
replace `Ib'difALL_`Prop' = `Ib'difALL_`Prop' + `Ib'Rorig`k'_`Prop'
foreach b of numlist 1/4 {
replace `Ib'B`b'_difALL_`Prop' = `Ib'B`b'_difALL_`Prop' + `Ib'Rorig`k'_`Prop'
}
foreach var1 of varlist `Ib'Rorig`k'_`Prop' `Ib'Rcf`k'_`Prop' `Ib'difALL_`Prop' `Ib'B*_difALL_`Prop' {
replace `var1' = . if cluster_`Prop'==1
}
} // `Ib'Rcf`k'*  `Ib'B1_Rcf`k'* `Ib'B2_Rcf`k'* //`Ib'B*_difALL_*
collapse `Ib'Rorig`k'* `Ib'difALL_* `Ib'B1_difALL_* `Ib'B2_difALL_* `Ib'B3_difALL_* `Ib'B4_difALL_* [fw=factor_all], by(`RV`kv'')   
export excel using "$path_t\\counterfactuals_RenM\\`Ib'\\RenHip_OrCf_`RV`kv''.xlsx", firstrow(variables) nolabel replace 
use "$path4b\\Rene_EFHall.dta", clear
drop *otp1 *otp2 *otp3  
local k=5
foreach Prop in "VIV" "vp" "OTP" { 
replace `Ib'difALL_`Prop' = `Ib'difALL_`Prop' + `Ib'Rorig`k'_`Prop'
foreach b of numlist 1/4 {
replace `Ib'B`b'_difALL_`Prop' = `Ib'B`b'_difALL_`Prop' + `Ib'Rorig`k'_`Prop'
}
foreach var1 of varlist `Ib'Rorig`k'_`Prop' `Ib'Rcf`k'_`Prop' `Ib'difALL_`Prop' `Ib'B*_difALL_`Prop' {
replace `var1' = . if cluster_`Prop'==1
}
}
collapse `Ib'Rorig`k'* `Ib'difALL_* `Ib'B1_difALL_* `Ib'B2_difALL_* `Ib'B3_difALL_* `Ib'B4_difALL_* [fw=factor_all], by(`RV`kv'')
export excel using "$path_t\\counterfactuals_RenM\\`Ib'\\ICdif_RenHip_OrCf_`RV`kv''.xlsx", firstrow(variables) nolabel replace 
}
}
}
clear 
