use "$path_bs_do\EFH_2014_08\EFH_14_allvars.dta", clear
capture drop a1
g a1=(ord==1)
g folio_efh=folio
g year_efh=2014
keep if a1==1
sum e18* e24* e28* e31*
rename e18 Hinstitucion_vp    // e24 after renegotiation
capture rename e18_2e Hbancofin_vp  // e24_2e after renegotiation
replace e28=e31 if e28<=0
rename e28 Htasa_vp   // note that format changed from before 2014
sum e55* e61* e65* e68*
forv k=1/3 { 
rename e55_`k' Hinstitucion_otp`k'   // e61 after renegotiation
capture rename e55_2e_`k' Hbancofin_otp`k'  // e61_2e after renegotiation
replace e65_`k'=e68_`k' if e65_`k'<=0
rename e65_`k' Htasa_otp`k'
}
global Hbnames "Hbancofin_vp"
do "$path_bs_do2\bank_names_ids.do"
keep folio_efh year_efh Hi* Hb* Ht*  //joinby year_efh folio_efh using "$path4b\\data_temp.dta", unmatched(both) update
capture drop _merge
save "$path4b\\data_temp.dta", replace

use "$path0\2017\EFH_17_allvars.dta", clear
capture drop a1
g a1=(ord==1)
g folio_efh=folio
g year_efh=2017
keep if a1==1
sum e13* e19* e23*
rename e13 Hinstitucion_vp    // e19 after renegotiation
label copy e13 HipInstitucionId
label save e13 using "$path4b\\HipInstitucionId.do", replace
capture rename e13_2e Hbancofin_vp  // e19_2e after renegotiation
rename e23 Htasa_vp   // note that format changed from before 2014
sum e55* e60* e64*
forv k=1/3 { 
rename e55_`k' Hinstitucion_otp`k'   // e60 after renegotiation
capture rename e55_2e_`k' Hbancofin_otp`k'  // e60_2e after renegotiation
rename e64_`k' Htasa_otp`k'
}
keep folio_efh year_efh Hi* Hb* Ht*
joinby year_efh folio_efh using "$path4b\\data_temp.dta", unmatched(both) update
capture drop _merge
order folio_efh year_efh, first
label copy e13_2e BancoLabId  // label values `var' BancoLabId  
label save e13_2e using "$path4b\\BankLabel.do", replace
save "$path4b\\data_temp.dta", replace    //tostring Hbancofin_vp, gen(Hbancofin_vp_str) 
save "$path4b\\data_temp14_17.dta", replace 

use "$path0\2007\Data\Base_trabajo\EFH_07_allvars.dta", clear
g folio_efh=folio
g year_efh=2007
keep if a1==1   
sum e15i* e21h* e22h*
rename e15i Hinstitucion_vp  // 2=banco
capture rename e15ie Hbancofin_vp  // Name of banco or financial institution
rename e21h Htipo_vp  // 1 = fija
rename e22h Htasa_vp   // 55 = 5.5%
sum e41i* e46h* e47h*
forv k=1/3 { 
rename e41i_tp`k' Hinstitucion_otp`k'
capture rename e41ie*_tp`k' Hbancofin_otp`k'
rename e46h_tp`k' Htipo_otp`k'
rename e47h_tp`k' Htasa_otp`k'
}
keep folio_efh year_efh Hi* Hb* Ht*
sum Hbancofin_otp1 Hbancofin_otp2 Hbancofin_otp3
recode Hbancofin_otp1 8/9=. 11=11 12=3 13=5 14=1 15=1 16=2 18=19 19=1 20=6 21=4 22=12 23=19 ///
24=13 26=. 27=8 28=4 29=10 40=3 56=. 60=1 61=13 63=1 64=. 48=. 57=. 67=. 33=. 34=14
recode Hbancofin_otp2 8/9=. 11=11 12=3 13=5 14=1 15=1 16=2 18=19 19=1 20=6 21=4 22=12 23=19 24=13 26=. 27=8 28=4 29=10 40=3 56=. 60=1 61=13 63=1 64=. 48=. 57=. 67=. 33=. 34=14
recode Hbancofin_otp3 8/9=. 11=11 12=3 13=5 14=1 15=1 16=2 18=19 19=1 20=6 21=4 22=12 23=19 24=13 26=. 27=8 28=4 29=10 40=3 56=. 60=1 61=13 63=1 64=. 48=. 57=. 67=. 33=. 34=14
run "$path4b\BankLabel.do"
label values Hbancofin_otp1 e13_2e
label values Hbancofin_otp2 e13_2e
label values Hbancofin_otp3 e13_2e
save "$path4b\\data_temp.dta", replace

use "$path0\2008\Data\Base_trabajo\EFH_08_allvars.dta", clear
g folio_efh=folio
g year_efh=2008
keep if a1==1
sum e8i* e12* e13*
rename e8i Hinstitucion_vp  
capture rename e8ie Hbancofin_vp  
capture rename e8iecod HbancofinCod_vp  
rename e12h Htipo_vp  
rename e13h Htasa_vp   
sum e32i* e37* e38*
forv k=1/3 { 
rename e32i_tp`k' Hinstitucion_otp`k'
capture rename e32ie*_tp`k' Hbancofin_otp`k'
capture rename e32iecod*_tp`k' HbancofinCod_otp`k'  
rename e37h_tp`k' Htipo_otp`k'
rename e38h_tp`k' Htasa_otp`k'
}
keep folio_efh year_efh Hi* Hb* Ht*
global Hbnames "Hbancofin_vp"
do "$path_bs_do2\bank_names_ids.do"
recode HbancofinCod_vp 1=3 2=1 3=11 4=4 5=19 6=6 7=5 8=19 9=10 10=4 11=1 12=11 13=8 14=11 15=15 16/20=. 21=3 22/28=. ///
29=17 30/32=. 33=1 98/99=.
run "$path4b\BankLabel.do"
label values Hbancofin_vp e13_2e
label values HbancofinCod_vp e13_2e
save "$path4b\\data_temp_08.dta", replace
joinby year_efh folio_efh using "$path4b\\data_temp.dta", unmatched(both) update
drop _merge
save "$path4b\\data_temp.dta", replace

use "$path0\2009\Data\Base_trabajo\EFH_09_allvars.dta", clear
g folio_efh=folio
g year_efh=2009
keep if a1==1
sum e8i* e12* e13*
rename e8i Hinstitucion_vp  
capture rename e8ie Hbancofin_vp  
capture rename e8iecod HbancofinCod_vp  
rename e12h Htipo_vp  
rename e13h Htasa_vp   
sum e32i* e37* e38*
forv k=1/3 { 
rename e32i_tp`k' Hinstitucion_otp`k'
capture rename e32ie*_tp`k' Hbancofin_otp`k'
capture rename e32iecod*_tp`k' HbancofinCod_otp`k'  
rename e37h_tp`k' Htipo_otp`k'
rename e38h_tp`k' Htasa_otp`k'
}
keep folio_efh year_efh Hi* Hb* Ht* //global Hbnames "Hbancofin_vp"  *do "$path_bs_do2\bank_names_ids.do"
recode Hbancofin_vp 8/9=. 11=11 12=3 13=5 14=1 15=1 16=2 18=19 19=1 20=6 21=4 22=12 23=19 ///
24=13 26=. 27=8 28=4 29=10 30=15 32=11 33=. 34=14 37=15 39=1 40=3 44=. 46=17 49/53=. 56=. 58=3 60=1 61=13 63=1 64=. 48=. 57=. 65/67=. 
recode Hbancofin_otp1 8/9=. 11=11 12=3 13=5 14=1 15=1 16=2 18=19 19=1 20=6 21=4 22=12 23=19 24=13 26=. 27=8 28=4 29=10 30=15 32=11 33=. 34=14 37=15 39=1 40=3 44=. 46=17 49/53=. 56=. 58=3 60=1 61=13 63=1 64=. 48=. 57=. 65/67=. 
recode Hbancofin_otp2 8/9=. 11=11 12=3 13=5 14=1 15=1 16=2 18=19 19=1 20=6 21=4 22=12 23=19 24=13 26=. 27=8 28=4 29=10 30=15 32=11 33=. 34=14 37=15 39=1 40=3 44=. 46=17 49/53=. 56=. 58=3 60=1 61=13 63=1 64=. 48=. 57=. 65/67=. 
recode Hbancofin_otp3 8/9=. 11=11 12=3 13=5 14=1 15=1 16=2 18=19 19=1 20=6 21=4 22=12 23=19 24=13 26=. 27=8 28=4 29=10 30=15 32=11 33=. 34=14 37=15 39=1 40=3 44=. 46=17 49/53=. 56=. 58=3 60=1 61=13 63=1 64=. 48=. 57=. 65/67=. 
run "$path4b\BankLabel.do"
label values Hbancofin_vp e13_2e
label values Hbancofin_otp1 e13_2e
label values Hbancofin_otp2 e13_2e
label values Hbancofin_otp3 e13_2e
save "$path4b\\data_temp_09.dta", replace
joinby year_efh folio_efh using "$path4b\\data_temp.dta", unmatched(both) update
drop _merge
save "$path4b\\data_temp.dta", replace
use "$path4b\\data_temp_08.dta", clear  //   //
replace year_efh=2009
joinby year_efh folio_efh using "$path4b\\data_temp_09.dta", unmatched(master) update
tab _merge
replace year_efh=2008
drop _merge
save "$path4b\\data_temp_08.dta", replace  
use "$path4b\\data_temp_09.dta", clear  
replace year_efh=2008
joinby year_efh folio_efh using "$path4b\\data_temp_08.dta", unmatched(master) update
tab _merge
replace year_efh=2009
drop _merge
save "$path4b\\data_temp_09.dta", replace  //   //
use "$path4b\\data_temp.dta", clear
joinby year_efh folio_efh using "$path4b\\data_temp_08.dta", unmatched(master) update
drop _merge
joinby year_efh folio_efh using "$path4b\\data_temp_09.dta", unmatched(master) update
drop _merge
save "$path4b\\data_temp.dta", replace

use "$path0\2010\Data\Base_trabajo\EFH_10_allvars.dta", clear
g folio_efh=folio
g year_efh=2010
keep if a1==1 
sum e12* e22* e23*
rename e12 Hinstitucion_vp  
capture rename e12_2e Hbancofin_vp  
capture rename e12_2ee_cod HbancofinCod_vp  
rename e22_h Htipo_vp  
rename e23_h Htasa_vp   
sum e43* e52* e53*
forv k=1/3 { 
rename e43_`k' Hinstitucion_otp`k'
capture rename e43_2e_`k' Hbancofin_otp`k'
capture rename e32iecod*_tp`k' HbancofinCod_otp`k'  
rename e52_h_`k' Htipo_otp`k'
rename e53_h_`k' Htasa_otp`k'
}
keep folio_efh year_efh Hi* Hb* Ht*
recode HbancofinCod_vp 1/2=. 3=19 4=1 5=17 6=8 8=15 9=. 98/99=.
run "$path4b\BankLabel.do"
label values HbancofinCod_vp e13_2e
label values Hbancofin_vp e13_2e
label values Hbancofin_otp1 e13_2e
label values Hbancofin_otp2 e13_2e
label values Hbancofin_otp3 e13_2e
joinby year_efh folio_efh using "$path4b\\data_temp.dta", unmatched(both) update
drop _merge
save "$path4b\\data_temp.dta", replace

use "$path0\2011\Data\Base_trabajo\EFH_11_allvars.dta", clear
g folio_efh=folio
g year_efh=2011
keep if a1==1  
sum e13* e23* e24*
rename e12 Hinstitucion_vp  
capture rename e13_2ee Hbancofin_vp  
capture rename e13_2eecod HbancofinCod_vp  
rename e23_h Htipo_vp  
rename e24_h Htasa_vp   
sum e41* e50* e51*
forv k=1/3 { 
rename e41_`k' Hinstitucion_otp`k'
capture rename e41_2e_`k' Hbancofin_otp`k'
capture rename e41_2ee_`k' HbancofinCod_otp`k'  
rename e50_h_`k' Htipo_otp`k'
rename e51_h_`k' Htasa_otp`k'
}
keep folio_efh year_efh Hi* Hb* Ht*
global Hbnames "Hbancofin_vp HbancofinCod_otp1 HbancofinCod_otp2 HbancofinCod_otp3"
do "$path_bs_do2\bank_names_ids.do"
recode HbancofinCod_vp 25=19 26=21 38=1 27/37=. 39/45=. 48=21 49/51=21 52=8 53=19 54=4 55/99=.
run "$path4b\BankLabel.do"
label values Hbancofin_vp e13_2e
label values HbancofinCod_vp e13_2e
label values HbancofinCod_otp1 e13_2e
label values HbancofinCod_otp2 e13_2e
label values HbancofinCod_otp3 e13_2e
joinby year_efh folio_efh using "$path4b\\data_temp.dta", unmatched(both) update
replace Hbancofin_vp=HbancofinCod_vp if Hbancofin_vp==.
replace Hbancofin_otp1=HbancofinCod_otp1 if Hbancofin_otp1==. 
replace Hbancofin_otp2=HbancofinCod_otp2 if Hbancofin_otp2==. 
replace Hbancofin_otp3=HbancofinCod_otp3 if Hbancofin_otp3==. 
drop _merge *Cod*
save "$path4b\\data_temp.dta", replace
joinby year_efh folio_efh using "$path4b\\data_temp14_17.dta", unmatched(both) update
drop _merge
order folio_efh year_efh Hi* Hb* Hta* Hti*, first
foreach var of varlist Hta* {
recode `var' -4/-1=. 980/999=.
replace `var' = `var'/10 if `var'>=20 & `var'<100
replace `var' = `var'/100 if `var'>=100 & `var'<800
}  
run "$path4b\HipInstitucionId.do"
label values Hinstitucion_vp e13
label values Hinstitucion_otp1 e13
label values Hinstitucion_otp2 e13
label values Hinstitucion_otp3 e13
save "$path4b\\data_temp.dta", replace
save "$path4b\\EFH_BancoMort_Tasas.dta", replace
