local p14 = "$path_bs_do\EFH_2014_08\"  //Nivel educacional 2011 n_educ: 0 Diferencial; 1 Pre-escolar y básica; 2 Media; 3 CFT-Instituto; 
local p17 = "$path0\2017\"            //   4 Universitaria;	5 Postgrado
use "$path0\2007\\Data\Base_trabajo\\EFH_07_allvars.dta", clear   
g folio_efh=folio
g year_efh=2007
keep if a1==1
g educ_ecf0 = n_educ // education_measure of ECF
recode educ_ecf0 0/1=1 2=2 3=3 4=4 5=5 7/.=1   
keep folio_efh year_efh educ_ecf0 n_educ
save "$path4b\\data_temp.dta", replace  
foreach yr in "08" "09" "10" "11" { // Format education for EFH 2014 and 2017
use "$path0\20`yr'\\Data\Base_trabajo\\EFH_`yr'_allvars.dta", clear   
g folio_efh=folio                         // 5 Universitaria; 6 Postgrado; 7 Otro
g year_efh=20`yr'	
keep if a1==1
g educ_ecf0 = n_educ // education_measure of ECF
recode educ_ecf0 0/1=1 2=2 3=3 4=4 5=5 7/.=1  
joinby folio_efh year_efh using "$path4b\\data_temp.dta", unmatched(both) update
tab _merge
drop _merge
keep folio_efh year_efh educ_ecf0 n_educ
save "$path4b\\data_temp.dta", replace  
}
foreach yr of numlist 14 17 { // Format education for EFH 2014 and 2017
use "`p`yr''\EFH_`yr'_allvars.dta", clear  //2014 n_educ: 0 Sin educación; 1 Ed. Diferencial; 2 Pre-escolar y básica; 3 Media; 4 CFT-Instituto
g folio_efh=folio                         // 5 Universitaria; 6 Postgrado; 7 Otro
g year_efh=20`yr'
capture drop a1
g a1=(ord==1)
keep if a1==1	
g educ_ecf0 = n_educ // education_measure of ECF
recode educ_ecf0 0/2=1 3=2 4=3 5=4 6=5 7/.=1  
joinby folio_efh year_efh using "$path4b\\data_temp.dta", unmatched(both) update
tab _merge
drop _merge
keep folio_efh year_efh educ_ecf0 n_educ
save "$path4b\\data_temp.dta", replace 							        
}
tab year_efh

local Vars1 = "edad5y sexo educ_ecf Pc2_income"  // too few observations per cell
local Vars2 = "edad10y sexo educ_ecf Pc2_income"  // too few observations per cell
local Vars = "tr_edad sexo educ_ecf Pc2_income"   // better, but observations still few (25% of the cells have 3 observations or less)
clear
import delimited "$path_bs_do2\data_EA\Base encuesta capacidades financieras Chile.txt", delimiter(";") varnames(1) 
save "$path4b\\ECF.dta", replace  
replace f_exp=ceil(f_exp) // expansion factor  
tab d7_a  // income level
tab zona
forv k=1/8 {
replace m0_v`k'=. if m0_v`k'>=6
} 
replace p2 = . if p2>=6
egen p1=rowmin(p10*)
egen c3=rowmin(c30*)
keep if zona==1
g tr_edad=edad
recode tr_edad 0/34=1 35/54=2 55/.=3
g edad5y = ceil(min(74,edad)/5)
g edad10y = ceil(min(74,edad)/10)
tab edad5y
label var fgse_educ "nivel de educacion JH"
label var fgse_act "nivel de actividad JH"
label var fgse "clasificación socio economica (CSE)"

// 0.0 Replicate financial education indexes of Atkinson and Messy, 2012
// 1.0 - indices de Conocimiento financiero (0 a 8) - Section 3.4
g A1 = (k1==200000) 	// division
g A2 = (k5_v2==1)		// valor en el tiempo
g A3 = (k2==3)  		// inflación
g A4 = (k3=="no") 		// tasas
g A5 = (k4_a==102000) 	// interés simple
g A6 = (k4_b==1)     	// interés compuesto
replace A6 = A6*A5
g A7 = (k5_v1==1)		// riesgo
g A8 = (k5_v3==1)		// diversificacion
egen iConoFin = rowtotal(A*)
sum iConoFin [fw=f_exp]  // Great! It replicates values in official report (page 50)
g high_iConoFin=(iConoFin>=6 & iConoFin<.)
tab high_iConoFin [fw=f_exp]

// 2.0 - Comportamiento financiero (0 a 8)
/*g B1 = (f1<=3)  		// Section 3.1: f1 Las decisiones sobre el manejo del dinero
g B2 = (f2_a==1)		// Elaboración y utilización de un presupuesto
g B3 = (f2_b==1)		// Elaboración y utilización de un presupuesto
g B4 = (f2_c==3)		// Elaboración y utilización de un presupuesto
g B5 = (f3==1)  		// Elaboración y utilización de un presupuesto: Gastos inesperados
/*drop c1*   // Section 3.2: Conocimiento de productos financieros:  conocimiento, tenencia y eleccion de 27 productos financieros
g B6 = (c2<.)			// Section 3.2: Conocimiento de productos financieros
g B7 = (c2<=2)			// Manera de elegir un producto financiero
drop c3*				// fuentes de información al elegir un producto financiero (15 fuentes)*/
g B6 = (c2<.)
*g B7 = (c2<=2)
g B8 = (m2==2)
g B7 = (p1<=8)*/
g B1 = (m0_v1>=4 & m0_v1<=5)
g B2 = (m0_v4>=4 & m0_v4<=5)
g B3 = (m0_v6>=4 & m0_v6<=5)
g B4 = (m0_v7>=4 & m0_v7<=5)
g B5 = (f2_a==1)  // & f2_b==1 & f2_c==3 Responsible and has a household budget
g B6 = (p1<=8) //(c2<.)    // Has been actively saving or buying investments in the past year
g aB7 = (c2<=2)      // …after  gathering  some info on financial products (Atkinson and Messy are just savings products)
g aB8 = (c3<=94)    // … after  shopping around and using independent info or advice (Atkinson and Messy are just savings products)
g B7_1 = (f2_c==3)   // f2_b==1 & 
g B8_1 = (f3==1)  //g B8_2 = (m2==2)
g aB9 = (m2==2)
egen iCompFin = rowtotal(B*)
sum iCompFin [fw=f_exp]  // Close to values on page 51, 52
g high_iCompFin=(iCompFin>=6 & iCompFin<.)
tab high_iCompFin [fw=f_exp]

// 3.0 índice de actitudes financieras (1 a 5)
// Section 3.3 “El dinero está ahí para ser gastado”, //
// “Prefiero vivir el día y no me preocupo por el mañana” y “Prefiero gastar dinero que ahorrar para el futuro”
egen iActFin = rowmean(m0_v2 m0_v3 m0_v8 m0_v5)  // Atkinson and Messy: just v2,v3,v8 // m0_v*
sum iActFin [fw=f_exp]  // Close to values on page 53
g high_iActFin=(iActFin>=3 & iActFin<.)
tab high_iActFin [fw=f_exp]

// 4.0 educación financiera (1 al 22): suma de los 3 indices anteriores
egen iEducFin = rowtotal(i*Fin aB*)  // use aB* or not
egen i2EducFin = rowtotal(iConoFin iCompFin aB*)
egen iInfoSFin = rowtotal(aB*)  // use aB* or not
pwcorr i*Fin fgse*

// 5.0 - measures of education and income
sum d4 d7_a fgse_educ fgse_act fgse
pwcorr d4 fgse_educ     // 2 measures of educacion
g educ_ecf1 = d4 // education_measure of ECF
recode educ_ecf1 1/4=1 5/8=2 9=3 10=4 11=5 12/.=1
g educ_ecf2 = fgse_educ 
recode educ_ecf2 1/2=1 3/4=2 5=3 6=4 7=5 8/.=1
tab educ_ecf1 educ_ecf2  // Good: both measures seem to match
pwcorr educ_ecf1 educ_ecf2
egen educ_ecf = rowmax(educ_ecf1 educ_ecf2)
pwcorr educ_ecf educ_ecf1 educ_ecf2
tab educ_ecf
// d7_a   Menos de $250.000. 	 1 	De $500.001 a $750.000   3 	De $1.000.001 a $1.400.000  5 	Más de $1.800.000 7
//        De $250.000 a $500.000 2 	De $750.001 a $1.000.000 4 	De $1.400.001. a $1.800.000 6 	No responde      99
//fgse  1=ABC1 (88-100 top income percentiles), 2=C2 (75-87 top pcs), 3=C3 (50-74 top pcs) 4=D (14-49 top pcs), 5=E (1-13 top pcs)
// EFH (ytot_p_h: percentiles) 1-13: <=375500, 14-49: 375500-835500, 50-74: 835500-1475000, 75-87: 1475000-2300000, 88-100: 2300000-.
//https://www.emol.com/noticias/Economia/2018/10/19/924437/El-perfil-de-los-siete-grupos-socioeconomicos-de-la-nueva-segmentacion-y-como-se-divide-la-poblacion-de-Chile.html
tab fgse_act fgse // higher values of fgse_act are better occupations, but higher values of fgse are lower social status
tab fgse_educ fgse  // higher values of fgse_educ are higher education
pwcorr d7_a fgse
g Pc_income = fgse  // fgse: lower values are higher income, if d7_a<=7
recode Pc_income 5=1 4=2 3=3 2=4 1=5  // Pc_income: lower values are lower income
recode Pc_income 5=4
g o_income = d7_a   // d7_a: lower values are lower income
recode o_income 1=1 2/3=2 4/5=3 6/7=4
replace o_income=Pc_income if o_income==99
tab Pc_income o_income
pwcorr Pc_income o_income
egen Pc2_income = rowmin(Pc_income o_income)
tab Pc2_income o_income
tab Pc2_income Pc_income
pwcorr Pc2_income o_income Pc_income  // good match between the first measure and other ones

tab sexo // 1=masculino 2=femenino // same as variable sexo in EFH
keep i*Fin edad10y sexo educ_ecf Pc2_income f_exp // d4 d7_a fgse_educ fgse_act fgse
save "$path4b\\ECF_x.dta", replace  
*g N=1
*collapse (sum) N (mean) i*Fin , by(`Vars') //[fw=f_exp]

local k=1
foreach var of varlist iEducFin i2EducFin iInfoSFin iConoFin iCompFin iActFin {
use "$path4b\\ECF_x.dta", clear   //reg `var' i.(edad10y sexo educ_ecf Pc2_income)
reg `var' i.(edad10y sexo educ_ecf Pc2_income) [pw=f_exp]  // Great: Linear regression looks good! //ereturn list

use  "$path4b\\hist_dynamic_un06_11_dtbc.dta", clear
joinby folio_efh year_efh using "$path4b\\data_temp.dta", unmatched(both) update
tab _merge
drop _merge
replace a1=(ord==1) if year_efh>=2014
keep if a1==1
egen y_min = rowmin(ytoth ytoth2 ytotef ytot_p_h)
pwcorr y_min ytoth ytoth2 ytotef ytot_p_h
g Pc2_income = 1 if y_min<250000 
replace Pc2_income = 2 if y_min>=250000 & y_min<750000
replace Pc2_income = 3 if y_min>=750000 & y_min<1400000
replace Pc2_income = 4 if y_min>=1400000 & y_min<.
g edad10y = ceil(min(74,edad)/10) 
tab nive_edu
g educ_ecf = nive_edu // education_measure of ECF
recode educ_ecf 1/4=1 5/11=2 12/13=3 14=4 15=5 16/.=1  //1/5=1 6/12=2 13=3 14=4 15=5 16/.=1 
replace educ_ecf=max(educ_ecf,educ_ecf0)
sum edad10y sexo educ_ecf Pc2_income   //ereturn list
predict `var'
keep folio_efh year_efh educ_ecf `var'
if `k'>1  {
joinby folio_efh year_efh using "$path4b\\iEducFin_EFH.dta", unmatched(both) update
tab _merge
drop _merge
} 
local k=1+`k'
save "$path4b\\iEducFin_EFH.dta", replace 
} 
sum
save "$path4b\\iEducFin_EFH.dta", replace 
