local VLN = ""   // 1.0 Format EFH mortgage contracts data
forv k=1/3 { 
local VL_Notp`k' = "yrPurchase_otp`k' yrCMortg_otp`k' mCMortg_otp`k' yrMatCMortg_otp`k' RenMortg_otp`k' RenMotMortg_otp`k'"
local VLN = "`VLN' `VL_Notp`k''"
}
local VL_N = "`VL_N' yrPurchase_vp yrCMortg_vp mCMortg_vp yrMatCMortg_vp RenMortg_vp RenMotMortg_vp"
local VLN = "`VLN' `VL_N'" 
local NVs = wordcount("`VLN'")
foreach YS in "07" "08" "09" "10" "11" "14" "17" { // 11, 14, 17 also have year-month of renegotiations
run "$path_bs_do2\HIPrenegociaciones_`YS'.do"
}
order folio_efh year_efh a1 factor* expr*, first
tab a1
drop a1
tab year_efh  //mean_wgts VacR_mE2V vacancy_arriendo year_Estrato_2V factor_egm   //bysort year Estrato_2V: sum vacancy_arriendo [fw=factor_egm]
save "$path4b\\HipReneg.dta", replace 
run "$path_bs_do2\format_montoDeuda.do" 

use "$path4b\\TSuf.dta", clear
sum UFm if year==2019
global UF2020 = r(mean)
use  "$path4b\\hist_dynamic_un06_11_dtbc.dta", clear // 2.0 - compute taxable income
g year_q4=year_efh
joinby year_q4 using "$path4b\\UF_yr_q4.dta", unmatched(master) update
tab _merge
drop _merge year_q4
g income = 0
foreach var of varlist ytot_ind* {
bysort folio_efh year_efh: egen var0=max(`var')
replace income =max(income, var0)
drop var0
}
keep if a1==1
replace income = ceil(12*income*${UF2020}/uf_yrq4)
replace income = 0 if income==.
keep folio_efh year_efh income uf_yrq4
g taxtau = income // for many people the marginal tax rate is 0
recode taxtau 0/8038926=0 8038926.1/17864280=0.04 17864280.1/29773800=0.08 29773800.1/41683320=0.135 41683320.1/53592840=0.23 ///
53592840.1/71457120=0.304 71457120/.=0.35
tab taxtau
/*   $0,00          $8.038.926,00       Exento      $0.00     (RENTA IMPONIBLE ANUAL and marginal tax rate)
$  8.038.926,01     $17.864.280,00       0,04       $321.557,04
$17.864.280.01       $29.773.800,00      0,08       $1.036.128,24
$29.773.800,01		$41.683.320,00       0,135      $2.673.687,24
$41.683.320,01      $53.592.840,00       0,23       $6.633.602,64
$53.592.840,01      $71.457.120,00       0,304      $10.599.472,80
$71.457.120,01 y más                     0,35       $13.886.500,32  */
save "$path4b\efh_income_mtax.dta", replace

use "$path4b\\HipReneg.dta", clear // 2.0 - Clean new mortgage variables and add interest rates for mortgages of that contractual period
foreach var of varlist yrP* yrC* {
quietly replace `var' = . if `var'>=2021
quietly replace `var' = . if `var'<=1899
}
sum yrP* yrC*
foreach var of varlist mC* {
quietly replace `var' = . if `var'>=13
quietly replace `var' = . if `var'<=0
}
sum mCMortg* 
foreach var of varlist yrM* {
quietly replace `var' = . if `var'>=61
quietly replace `var' = . if `var'<0
}
sum yrM*
foreach var of varlist Ren* {
quietly replace `var' = . if `var'>=8
quietly replace `var' = . if `var'<0
}
sum Ren*
g year = year_efh
g month = 7
joinby year month using "$path4b\\TSRates.dta", unmatched(master) update
rename Rmortgage RCmortg_efh
tab _merge
drop _merge year month
foreach Prop in "vp" "otp1" "otp2" "otp3" { 
g nr_pays_done = (year_efh-yrCMortg_`Prop')*12 - mCMortg_`Prop'
replace nr_pays_done = 0 if nr_pays_done<=0 & yrCMortg_`Prop'<. //sum nr_pays_done, d 
g anow = nr_pays_done-yrMatCMortg_`Prop'*12  // g MatLeft=yrMatCMortg_`Prop'*12-nr_pays_done  replace MatLeft=. if MatLeft<0
replace anow=. if anow>0
g aOrig = 0 - yrMatCMortg_`Prop'*12
g value_now = (1/RCmortg_`Prop') -   ( (RCmortg_`Prop'+1)^(anow) )/RCmortg_`Prop'
replace value_now=0 if value_now<=0
g value_orig = (1/RCmortg_`Prop') -   ( (RCmortg_`Prop'+1)^(aOrig) )/RCmortg_`Prop'
g rDOrigNow_`Prop' = value_orig/value_now   //sum value_orig value_now rDOrigNow_`Prop'
g Idiv_`Prop' = Ideuda_`Prop'/value_orig 
rename value_orig Ann_orig_`Prop'
drop nr_pays_done value_now anow aOrig // value_orig MatLeft
}
joinby folio_efh year_efh using "$path4b\efh_income_mtax.dta", unmatched(both) update
tab _merge
drop  _merge
g year = 1996 if _n==1
g month = 1 if _n==1
joinby year month using "$path4b\\TSRates.dta", unmatched(both) update
tab _merge
drop _merge
sort year month Rmortgage
save "$path4b\\HipReneg2.dta", replace
