pr def refinance_ADLoption
    args M taxtau I0 Mny_Gamma nr_draws

quietly {  // `nr_draws' must be a constant (choose 50, 100, 1000)
// variables: M is the real value of the mortgage debt; taxtau is the marginal tax rate of each observation (mortgage/household)
// I0 is the coupon of the mortgage contract, Mny_Gamma is the remaining maturity left to pay
// use yearly values for I0 and Mny_Gamma!
// Ka=npvK is the tax real cost of refinancing as a fixed NPV (see function refinance_npvKost.do for a formula)

refinance_npvKost ${Fcost} ${fpc} ${thetaADL} ${Nmyears} ${infR} `M' `taxtau'
refinance_Rlambda ${miuADL} `I0' `Mny_Gamma'

g psi = sqrt( 2*(${rho} + Rlambda) ) / ${Rsigma}
g phi = 1+psi*(${rho} + Rlambda) * (npvK/`M')/(1-`taxtau')

g Lzi = -exp(-phi)
lambert_w_integral Lzi `nr_draws'

g xADL = (1/psi) * ( phi + LwI)
drop Lzi npvK phi psi Rlambda LwI
}
end
