pr def refinance_ADLoptionMonthly
    args M taxtau I0 Mny_Gamma nr_draws

quietly {  // `nr_draws' must be a constant (choose 50, 100, 1000)
// variables: M is the real value of the mortgage debt; taxtau is the marginal tax rate of each observation (mortgage/household)
// Ka=npvK is the tax real cost of refinancing as a fixed NPV (see function refinance_npvKost.do for a formula)

refinance_npvKost ${Fcost} ${fpc} ${thetaADL} ${Nmyears} ${infR} `M' `taxtau'
refinance_Rlambda ${miuADL} `I0' `Mny_Gamma'
replace Rlambda = Rlambda/12
local rhoM = ${rho}/12  
local RsigmaM = ${Rsigma}/(sqrt(12)*12)

g psi = sqrt( 2*(`rhoM' + Rlambda) ) / `RsigmaM'
g phi = 1+psi*(`rhoM' + Rlambda) * (npvK/`M')/(1-`taxtau')

g Lzi = -exp(-phi)
lambert_w_integral Lzi `nr_draws'

g xADL = (1/psi) * ( phi + LwI)
replace xADL=xADL*12
drop Lzi npvK phi psi Rlambda LwI
}
end
