pr def refinance_PVgain2
    args M taxtau I0 Mny_Gamma Inew

quietly {  // Standard Present value gain (ignores miu μ the hazard rate of moving)
// variables: M is the real value of the mortgage debt; taxtau is the marginal tax rate of each observation (mortgage/household)
// Ka=npvK is the tax real cost of refinancing as a fixed NPV (see function refinance_npvKost.do for a formula)

refinance_npvKost ${Fcost} ${fpc} ${thetaADL} ${Nmyears} ${infR} `M' `taxtau'   //refinance_Rlambda ${miuADL} `I0' `Mny_Gamma'
g A1 = (1/`I0') - ( (`I0'+1)^(-`Mny_Gamma') )/`I0'
g A2 = (1/`Inew')-( (`Inew'+1)^(-`Mny_Gamma') )/`Inew'

g xPVgain2 = (A1*`I0'*`M'-A2*`Inew'*`M') - npvK/(1-`taxtau') // (npvK/`M')
drop npvK A1 A2 //Rlambda
}
end
