pr def refinance_Rlambda
    args miu I0 Mny_Gamma

quietly {  // lambda λ is the expected real rate of exogenous mortgage repayment (Agarwal et al JMCB 2013: pages 1, 12, 13)
// miu μ is the hazard rate of moving (ex: 0.05)
// I0 in Agarwal et al it is the original nominal interest rate of the mortgage (in Chile it is a real rate, because contracts are in real terms)
// M is the mortgage size
// Mny_Gamma = number of years of remaining years of the mortgage (ex: Mny_Gamma=15)
// infR=0.03  // assume for example inflation rate is 3% (Central Bank of Chile's inflation target)
if ${RMop}==0 {
local infRm=${infR}
}
if ${RMop}==1 {
local infRm=0
}
g Rlambda = `miu' + (`I0'/(exp(`I0'*`Mny_Gamma')-1)) + `infRm'
// last term in Agarwal et al is the annual inflation rate, but in Chile it is 0 (contracts are in real currency unit)

}
end
