local RV1 = "pop"  // 1.0: Welfare gains from renegotiation in Present Value times Probability of Renegotiating Mortgages
local RV2 = "quintile_h"
local RV3 = "Estrato_VIV"
local RV4 = "Estrato_vp"
local RV5 = "Estrato_OTP"
local RV6 = "educ_ecf"
local cf=""
local rf="xADL"  //local k=1   // use the PV formula of ADL
quietly { 
foreach Ib in "" "Hip_" { 
forv kv=1/6 {
use "$path4b\\Rene_EFHall.dta", clear   
drop *otp1 *otp2 *otp3  
local k=2
foreach Prop in "VIV" "vp" "OTP" { 
replace `Ib'difALL_`Prop' = `Ib'difALL_`Prop' + `Ib'Rorig`k'_`Prop'
foreach b of numlist 1/4 {
replace `Ib'B`b'_difALL_`Prop' = `Ib'B`b'_difALL_`Prop' + `Ib'Rorig`k'_`Prop'
}
foreach var1 of varlist `Ib'Rorig`k'_`Prop' `Ib'Rcf`k'_`Prop' `Ib'difALL_`Prop' `Ib'B*_difALL_`Prop' {
replace `var1' = . if cluster_`Prop'==1
}
foreach var1 of varlist `Ib'Rorig`k'_`Prop' { // Multiply probability of renegotiation mortgage with gain (before the law)
replace `var1' = `var1'*exp(PV1`cf'_`rf'_`Prop')  // Note - variable had previously been put in log
}
foreach var1 of varlist `Ib'Rcf`k'_`Prop' `Ib'difALL_`Prop' `Ib'B*_difALL_`Prop' {
replace `var1' = `var1'*exp(PV1A_`rf'_`Prop') // Multiply probability of renegotiation mortgage with gain (after the law)
}    //    //    //
} 
collapse `Ib'Rorig`k'* `Ib'difALL_* `Ib'B1_difALL_* `Ib'B2_difALL_* `Ib'B3_difALL_* `Ib'B4_difALL_* [fw=factor_all], by(`RV`kv'')   
export excel using "$path_t\\counterfactuals_RenM\\`Ib'\\PV_RenHip_OrCf_`RV`kv''.xlsx", firstrow(variables) nolabel replace 
use "$path4b\\Rene_EFHall.dta", clear
drop *otp1 *otp2 *otp3  
local k=5
foreach Prop in "VIV" "vp" "OTP" { 
replace `Ib'difALL_`Prop' = `Ib'difALL_`Prop' + `Ib'Rorig`k'_`Prop'
foreach b of numlist 1/4 {
replace `Ib'B`b'_difALL_`Prop' = `Ib'B`b'_difALL_`Prop' + `Ib'Rorig`k'_`Prop'
}
foreach var1 of varlist `Ib'Rorig`k'_`Prop' `Ib'Rcf`k'_`Prop' `Ib'difALL_`Prop' `Ib'B*_difALL_`Prop' {
replace `var1' = . if cluster_`Prop'==1
}
foreach var1 of varlist `Ib'Rorig`k'_`Prop' { // Multiply probability of renegotiation mortgage with gain (before the law)
replace `var1' = `var1'*exp(PV1`cf'_`rf'_`Prop') // Note - variable had previously been put in log
}
foreach var1 of varlist `Ib'Rcf`k'_`Prop' `Ib'difALL_`Prop' `Ib'B*_difALL_`Prop' {
replace `var1' = `var1'*exp(PV1A_`rf'_`Prop') // Multiply probability of renegotiation mortgage with gain (after the law)
}    //    //    //
}
collapse `Ib'Rorig`k'* `Ib'difALL_* `Ib'B1_difALL_* `Ib'B2_difALL_* `Ib'B3_difALL_* `Ib'B4_difALL_* [fw=factor_all], by(`RV`kv'')
export excel using "$path_t\\counterfactuals_RenM\\`Ib'\\PV_ICdif_RenHip_OrCf_`RV`kv''.xlsx", firstrow(variables) nolabel replace 
}
}
}
clear 

local RMv = "RenMortg_VIV RenMortg_vp RenMortg_OTP"    // 2.0 Descriptive Stats of Financial Education
use  "$path4b\\Rene_EFHall.dta", clear  // foreach Prop in "VIV" "vp" "OTP" "otp1" "otp2" "otp3" {  }
sum quintile_h
collapse i*Fin `RMv'  [fw=factor_all], by(quintile_h)
export excel using "$path_t\\educ\\RenHip_iEduc_quintile.xlsx", firstrow(variables) nolabel replace 
use  "$path4b\\Rene_EFHall.dta", clear  
sum universidad educ_ecf nive_edu
collapse i*Fin `RMv'  [fw=factor_all], by(educ_ecf)
export excel using "$path_t\\educ\\RenHip_iEduc.xlsx", firstrow(variables) nolabel replace 
use  "$path4b\\Rene_EFHall.dta", clear  
sum quintile_h
collapse i*Fin `RMv'  [fw=factor_all]
export excel using "$path_t\\educ\\RenHip_iEduc_all.xlsx", firstrow(variables) nolabel replace 
use  "$path4b\\Rene_EFHall.dta", clear  
collapse i*Fin RenMortg_vp RenMortg_OTP [fw=factor_all], by(RenMortg_VIV)  // RenMortg_VIV RenMortg_vp RenMortg_OTP
export excel using "$path_t\educ\iEduc_Ren01_VIV.xlsx", firstrow(variables) nolabel replace 

foreach Prop in "VIV" "vp" "OTP" {     // 3.0 Descriptive Stats by the financial or bank institution of the mortgage plus other stats
use  "$path4b\\Rene_EFHall.dta", clear  
g dif_`Prop'=year_efh-yrCMortg_`Prop'
sum dif_`Prop' if deuda_hip_`Prop'>0 & deuda_hip_`Prop'<., d
replace yrCMortg_`Prop'=year_efh-r(p50) if yrCMortg_`Prop'==.
recode yrCMortg_`Prop' 1900/1990=1990
replace yrCMortg_`Prop' = 5*ceil(yrCMortg_`Prop'/5)
collapse `RMv' [fw=factor_all], by(yrCMortg_`Prop')   
export excel using "$path_t\\Ren\\RenYr_`Prop'.xlsx", firstrow(variables) nolabel replace 
use  "$path4b\\Rene_EFHall.dta", clear  
replace yrMatCMortg_`Prop'=20 if yrMatCMortg_`Prop'==.  // mode and median outcome is 20 years
replace yrMatCMortg_`Prop'=min(40,yrMatCMortg_`Prop') if yrMatCMortg_`Prop'<.
replace yrMatCMortg_`Prop'=5*ceil(yrMatCMortg_`Prop'/5)
collapse `RMv' [fw=factor_all], by(yrMatCMortg_`Prop')   
export excel using "$path_t\\Ren\\RenMat_`Prop'.xlsx", firstrow(variables) nolabel replace 

use  "$path4b\\Rene_EFHall.dta", clear 
collapse act_tot_`Prop' roa_`Prop' roe_`Prop' Hip_Oacum_vintage_`Prop' Hip_Dacum_vintage_`Prop'  [fw=factor_all], by(RenMortg_`Prop')
export excel using "$path_t\\Ren\\RenHip_BSheetSLO_`Prop'.xlsx", firstrow(variables) nolabel replace 

use  "$path4b\\Rene_EFHall.dta", clear // 1=Chile 3=Estado 4=SCOTIA 6=BCI 10=BICE 11=Santander 13+8=Itau,CorpBanca 14=SECURITY 15=FALABELLA 16=RIPLEY
drop if RenMortg_`Prop'==.
drop if cluster_`Prop'==.
collapse (sum) pop (mean) `RMv' [fw=factor_all], by(cluster_`Prop') // cluster_`Prop'
sum pop, d
replace pop=pop/r(sum)
export excel using "$path_t\\Ren\\RenHip_cluster_`Prop'.xlsx", firstrow(variables) nolabel replace 
use  "$path4b\\Rene_EFHall.dta", clear // 1=Chile 3=Estado 4=SCOTIA 6=BCI 10=BICE 11=Santander 13+8=Itau,CorpBanca 14=SECURITY 15=FALABELLA 16=RIPLEY
drop if RenMortg_`Prop'==.
drop if cluster_`Prop'==.
recode cluster_`Prop' 11/14=7
collapse (sum) pop (mean) `RMv' [fw=factor_all], by(cluster_`Prop') // cluster_`Prop'
sum pop, d
replace pop=pop/r(sum)
export excel using "$path_t\\Ren\\RenHip_cluster2_`Prop'.xlsx", firstrow(variables) nolabel replace 

use  "$path4b\\Rene_EFHall.dta", clear 
g banco_EFH = Hbancofin_`Prop'  
recode banco_EFH 2=1 5=4 7=6 9=8 12=11 20=19 17=21 16=15 18=15 14=21 //replace banco_EFH=21 if banco_EFH==. & Hinstitucion_`Prop'==2
drop if RenMortg_`Prop'==.
drop if banco_EFH==.
collapse (sum) pop (mean) `RMv' [fw=factor_all], by(banco_EFH)
sum pop, d
replace pop=pop/r(sum)
export excel using "$path_t\\Ren\\RenHip_banco_`Prop'.xlsx", firstrow(variables) nolabel replace 
}
use  "$path4b\\Rene_EFHall.dta", clear 
keep Hbancofin_* Hinstitucion_* folio_efh year_efh factor_all `RMv'
drop if RenMortg_VIV==.
drop Hbancofin_VIV Hbancofin_OTP Hinstitucion_VIV Hinstitucion_OTP
rename Hbancofin_vp Hbancofin_otp0
rename Hinstitucion_vp Hinstitucion_otp0
reshape long Hbancofin_otp Hinstitucion_otp, i(folio_efh year_efh factor_all) j(Prop)
g pop=1
g banco_EFH = Hbancofin_  
recode banco_EFH 2=1 5=4 7=6 9=8 12=11 20=19 17=21 16=15 18=15 14=21 //replace banco_EFH=21 if banco_EFH==. & Hinstitucion_==2
drop if banco_EFH==.
save  "$path4b\\Rene_EFHall_long.dta", replace
collapse (sum) pop (mean) `RMv' [fw=factor_all], by(banco_EFH)
sum pop, d
replace pop=pop/r(sum)
export excel using "$path_t\\Ren\\RenHip_banco_VIV2.xlsx", firstrow(variables) nolabel replace 
use  "$path4b\\Rene_EFHall_long.dta", clear
drop if Prop==0
drop if RenMortg_OTP==.
collapse (sum) pop (mean) `RMv' [fw=factor_all], by(banco_EFH)
sum pop, d
replace pop=pop/r(sum)
export excel using "$path_t\\Ren\\RenHip_banco_OTP2.xlsx", firstrow(variables) nolabel replace  

use  "$path4b\\Rene_EFHall.dta", clear 
keep cluster_* folio_efh year_efh factor_all `RMv'
drop if RenMortg_VIV==.
drop cluster_VIV cluster_OTP 
rename cluster_vp cluster_otp0
reshape long cluster_otp, i(folio_efh year_efh factor_all) j(Prop)
g pop=1
drop if cluster_otp==.
save  "$path4b\\Rene_EFHall_long.dta", replace
collapse (sum) pop (mean) `RMv' [fw=factor_all], by(cluster_otp)
sum pop, d
replace pop=pop/r(sum)
export excel using "$path_t\\Ren\\RenHip_cluster_VIV2.xlsx", firstrow(variables) nolabel replace 
use  "$path4b\\Rene_EFHall_long.dta", clear
drop if Prop==0
drop if RenMortg_OTP==.
collapse (sum) pop (mean) `RMv' [fw=factor_all], by(cluster_otp)
sum pop, d
replace pop=pop/r(sum)
export excel using "$path_t\\Ren\\RenHip_cluster_OTP2.xlsx", firstrow(variables) nolabel replace  
use  "$path4b\\Rene_EFHall_long.dta", clear
recode cluster_otp 11/14=7
save  "$path4b\\Rene_EFHall_long.dta", replace
collapse (sum) pop (mean) `RMv' [fw=factor_all], by(cluster_otp)
sum pop, d
replace pop=pop/r(sum)
export excel using "$path_t\\Ren\\RenHip_cluster2_VIV2.xlsx", firstrow(variables) nolabel replace 
use  "$path4b\\Rene_EFHall_long.dta", clear
drop if Prop==0
drop if RenMortg_OTP==.
collapse (sum) pop (mean) `RMv' [fw=factor_all], by(cluster_otp)
sum pop, d
replace pop=pop/r(sum)
export excel using "$path_t\\Ren\\RenHip_cluster2_OTP2.xlsx", firstrow(variables) nolabel replace 
