/*   $0,00          $8.038.926,00       Exento      $0.00     (RENTA IMPONIBLE ANUAL and marginal tax rate)
$  8.038.926,01     $17.864.280,00       0,04       $321.557,04
$17.864.280.01       $29.773.800,00      0,08       $1.036.128,24
$29.773.800,01		$41.683.320,00       0,135      $2.673.687,24
$41.683.320,01      $53.592.840,00       0,23       $6.633.602,64
$53.592.840,01      $71.457.120,00       0,304      $10.599.472,80
$71.457.120,01 y más                     0,35       $13.886.500,32  */
global rho = 0.05 // the real discount rate (Agarwal et al JMCB 2013: rho=0.05)
global Fcost = 2000
global fpc=0.01
global miuADL = 0.05 // Agarwal et al 2013: miu=10% (page 13). Hayre et al (2000) estimate that 5–7% of single-family homes turnover per year.
global thetaADL = ${miuADL}+0.01   // Agarwal et al 2013: use miu + 10% (probability of exogenous refinancing)
global Nmyears = 25
global infR = 0.03
global RMop = 1 // Contracts are in Real terms
use "$path4b\TSRates.dta", clear  // drop if year<=2002
sort year month
egen time=group(year month)
tsset time
g dRm = L.Rmortgage
replace dRm=(Rmortgage-dRm)/100
g M=1000*1000
g taxtau=0.35
g Rmortgage_adl=Rmortgage/100
sum dRm if year>=2003, d //sum Rmortgage_adl if year>=2003, d  // choose if year>=2003 or >=2010
global Rsigma = r(sd)*sqrt(12) //r(sd)*sqrt(12) // Agarwal et al JMCB 2013: mortgage sigma = 0.0109 = monthly standard-deviation 0.00315 x sqrt(12)
display("${Rsigma}")

refinance_npvKost ${Fcost} ${fpc} ${thetaADL} ${Nmyears} ${infR} M taxtau
g I0 = 0.06
g Mny_Gamma =15
refinance_Rlambda ${miuADL} I0 Mny_Gamma  // expected real rate of exogenous mortgage repayment 
sum npvK Rlambda //, d
drop Rlambda npvK

refinance_ADLoption M taxtau I0 Mny_Gamma 100
sum xADL, d
rename xADL xADL0
refinance_ADLoptionMonthly M taxtau I0 Mny_Gamma 100
refinance_PVbreakeven M taxtau I0 Mny_Gamma
refinance_ADLsqroot M taxtau I0 Mny_Gamma

sum xPV xSqr xADL0 xADL, d  // Great! Results make sense

// Try to replicate ADL Table 1, 2 and 3
global Rsigma=0.0109
global miuADL = 0.10
global thetaADL = ${miuADL}+0.00  
global RMop = 0 // Contracts are Nominal
global Nmyears = 30
clear
set obs 4
g z = 2*ln(2) if _n==1
replace z = 0 if _n==2  //replace z = -1/exp(1) if _n==3  replace z = -_pi/2 if _n==4
lambert_w_integral z 100
tab LwI
drop LwI

g M = 1000*1000 if _n==1
replace M=500*1000 if _n==2
replace M=250*1000 if _n==3
replace M=100*1000 if _n==4
g taxtau=0.35
g I0 = 0.06
g Mny_Gamma =25
refinance_Rlambda ${miuADL} I0 Mny_Gamma  // expected real rate of exogenous mortgage repayment 
refinance_npvKost ${Fcost} ${fpc} ${thetaADL} ${Nmyears} ${infR} M taxtau
sum npvK Rlambda //, d
tab npvK
drop npvK Rlambda 
refinance_ADLoption M taxtau I0 Mny_Gamma 1000
tab xADL  // Great! First and Last column of Table 2 almost exactly
drop xADL
replace taxtau=0.28
refinance_ADLoption M taxtau I0 Mny_Gamma 1000
refinance_PVbreakeven M taxtau I0 Mny_Gamma
refinance_ADLsqroot M taxtau I0 Mny_Gamma
tab xADL   // Great! First and 3rd columns of Table 3 almost exactly
tab xADL xSqr   // Great! columns 1, 2, 3 of Table 1 almost exactly
tab xADL xPV // Great! columns 1, 2, 5 of Table 1 almost exactly
refinance_PVgain M taxtau I0 Mny_Gamma 0.045
tab xPVgain1
refinance_PVgain2 M taxtau I0 Mny_Gamma 0.045
tab xPVgain2 
tab xPVgain2 xPVgain1
clear
